/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  This code is generated by JAC version 5.0 by
  Agent Oriented Software. http://www.agent-software.com.au

    DO NOT ALTER THIS CODE AND DO NOT REMOVE THIS COMMENT
 *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
package berth;
import aos.jack.jak.plan.Plan;
import aos.jack.jak.plan.PlanFSM;
import aos.jack.jak.plan.ExMap;
import aos.jack.jak.agent.NameSpace;
import aos.jack.jak.event.Event;
import aos.jack.jak.task.Task;
import aos.jack.jak.core.Generator;
import aos.jack.jak.logic.Signature;
import java.util.ArrayList;
import com.domainlanguage.time.Duration;
import com.domainlanguage.time.TimePoint;
import gui.Ship;
import java.lang.Object;
import aos.jack.jak.cursor.Cursor;
import aos.jack.jak.fsm.FSM;
import aos.jack.jak.core.Jak;

/**Plan AllocateShipNearWantedArrivalTime
 * 
 * If the berth is available at the ship's wanted arrival time, the ship is allocated at this 
 * timepoint. If not, this plan tries to allocate the ship as close as possible
 * to wanted arrival time. When a suggestion for ship allocation is found, the Berth
 * calculates the cost and sends a Bid to the Jettyplanner.
 * 
 * @author Mari Torgersrud Haug
 * @author Elin M Kristensen
 * @version 29.05.06
 * 
 * @see AllocationRequest
 */

public class AllocateShipNearWantedArrivalTime extends aos.jack.jak.plan.Plan {
    public berth.AllocationRequest ev;
    public berth.Berth self;
    private static aos.jack.jak.plan.ExMap[] __exMap_body;
    private static java.lang.String[] __tt__body = {
            "berth/AllocateShipNearWantedArrivalTime.plan",
            "body",
            "65",
            "67",
            "68",
            "69",
            "70",
            "71",
            "73",
            "74",
            "75",
            "76",
            "77",
            "78",
            "79",
            "80",
            "83",
            "86",
            "87",
            "88",
            "89",
            "90",
            "91",
            "91",
            "92",
            "93",
            "94",
            "91",
            "97",
            "100",
            "62"};
    private static aos.jack.jak.plan.ExMap[] __exMap_sendCost;
    private static java.lang.String[] __tt__sendCost = {
            "berth/AllocateShipNearWantedArrivalTime.plan",
            "sendCost",
            "107",
            "108",
            "109",
            "110",
            "105"};
    private final static java.lang.String[] __planVariableNames = {
            "ev",
            "self"};
    private final static java.lang.String[] __planVariableTypes = {
            "berth.AllocationRequest",
            "berth.Berth"};
    private final static java.lang.String[] __reasoningMethods = {
            "sendCost",
            "body"};
    private final static java.lang.String[] __fsmVariableNames_body = {
            "shipList",
            "wantedArrivalTime",
            "durationOfCharging",
            "wantedDepartureTime",
            "shipToBeMovedList",
            "wantedIndex",
            "i",
            "intersectionBetweenShips",
            "ship",
            "isKnockedOut",
            "shipWanted",
            "j",
            "ship"};
    private final static java.lang.String[] __fsmTypes_body = {
            "ArrayList",
            "TimePoint",
            "Duration",
            "TimePoint",
            "ArrayList",
            "int",
            "int",
            "boolean",
            "Ship",
            "boolean",
            "Ship",
            "int",
            "Ship"};
    private final static java.lang.String[] __fsmLocalNames_body = {
            "__local__2_0",
            "__local__2_1",
            "__local__2_2",
            "__local__2_3",
            "__local__2_4",
            "__local__2_5",
            "__local__2_6",
            "__local__2_7",
            "__local__2_8",
            "__local__2_9",
            "__local__2_10",
            "__local__2_11",
            "__local__2_12"};
    private final static java.lang.String[] __fsmVariableNames_sendCost = {
            "arrivalDay",
            "durationOfCharging",
            "index",
            "shipToBeMovedList",
            "calculatedCost",
            "bid"};
    private final static java.lang.String[] __fsmTypes_sendCost = {
            "TimePoint",
            "Duration",
            "int",
            "ArrayList",
            "int",
            "Bid"};
    private final static java.lang.String[] __fsmLocalNames_sendCost = {
            "arrivalDay",
            "durationOfCharging",
            "index",
            "shipToBeMovedList",
            "__local__3_4",
            "__local__3_5"};
    /**
     * The method checks if the wanted timeslot is occupied by comparing
     * arrival time and departure time of two ships.
     * @param TimePoint wantedArrivalTime
     * @param TimePoint wantedDepartureTime
     * @param TimePoint delegatedArrivalTimeOtherShip
     * @param TimePoint departureTimeOtherShip
     * @return boolean true or false
     */

    private boolean wantedTimeArrivalOccupied(gui.Ship ship, com.domainlanguage.time.TimePoint wantedArrivalTime, com.domainlanguage.time.TimePoint wantedDepartureTime)
    {
        boolean insideOccupied = (wantedArrivalTime.isAfter(ship.getDelegatedArrivalTime()) && !wantedDepartureTime.isAfter(ship.getDepartureTime()));
        boolean startOccupied = (!wantedArrivalTime.isAfter(ship.getDelegatedArrivalTime()) && wantedDepartureTime.isAfter(ship.getDelegatedArrivalTime()));
        boolean endOccupied = (!wantedArrivalTime.isAfter(ship.getDepartureTime()) && wantedDepartureTime.isAfter(ship.getDepartureTime()));
        boolean equalTime = wantedArrivalTime.equals(ship.getDelegatedArrivalTime());
        boolean occupied = insideOccupied || startOccupied || endOccupied || equalTime;
        java.lang.System.out.println("Time interval is occupied by " + ship.getName() + "is true :" + occupied);
        return occupied;
    }
    
    static boolean relevant(berth.AllocationRequest ev)
    {
        return true;
    }
    
    public java.lang.String getDocumentation()
    {
        return "/**Plan AllocateShipNearWantedArrivalTime\n * \n * If the berth is available at the ship\'s wanted arrival time, the ship is allocated at this \n * timepoint. If not, this plan tries to allocate the ship as close as possible\n * to wanted arrival time. When a suggestion for ship allocation is found, the Berth\n * calculates the cost and sends a Bid to the Jettyplanner.\n * \n * @author Mari Torgersrud Haug\n * @author Elin M Kristensen\n * @version 29.05.06\n * \n * @see AllocationRequest\n */\n";
    }
    
    public AllocateShipNearWantedArrivalTime()
    {
    }
    
    private AllocateShipNearWantedArrivalTime(aos.jack.jak.task.Task __t, berth.AllocateShipNearWantedArrivalTime __env)
    {
        __agent = __env.__agent;
        __ns = __env.__ns;
        __planTask = __t;
        __logic = __t.logic;
        ev = __env.ev;
        self = (berth.Berth) __ns.getIF(berth.Berth.class);
    }
    
    public boolean init_sentinel(aos.jack.jak.agent.NameSpace __a)
    {
        ev = (berth.AllocationRequest) __a.findEvent("berth.AllocationRequest");
        if (ev == null) {
            warning("Failed to find AllocationRequest ev");
            return false;
        }
        return true;
    }
    
    public aos.jack.jak.plan.Plan freeze()
    {
        return this;
    }
    
    public aos.jack.jak.plan.Plan unfreeze()
    {
        return this;
    }
    
    public java.lang.Object genObject(int __index)
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Object Construction");
        return null;
    }
    
    public aos.jack.jak.cursor.Cursor genCursor(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Cursor Construction");
        return null;
    }
    
    public aos.jack.jak.fsm.FSM genFSM(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal FSM Construction");
        return null;
    }
    
    public boolean testCondition(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal test Construction");
        return false;
    }
    
    public aos.jack.jak.plan.PlanFSM body()
    {
        return new berth.AllocateShipNearWantedArrivalTime.__bodyFSM();
    }
    
    public aos.jack.jak.plan.PlanFSM sendCost(com.domainlanguage.time.TimePoint arrivalDay, com.domainlanguage.time.Duration durationOfCharging, int index, java.util.ArrayList shipToBeMovedList)
    {
        return new berth.AllocateShipNearWantedArrivalTime.__sendCostFSM(arrivalDay,durationOfCharging,index,shipToBeMovedList);
    }
    
    private AllocateShipNearWantedArrivalTime(berth.AllocationRequest __ev, aos.jack.jak.task.Task __t, berth.AllocateShipNearWantedArrivalTime __env)
    {
        this(__t,__env);
        this.ev = __ev;
    }
    
    protected aos.jack.jak.logic.Signature eventSignature(int __log)
    {
        return ev.getSignature(__log);
    }
    
    public java.lang.String handledEvent()
    {
        return "berth.AllocationRequest";
    }
    
    public boolean __relevant(aos.jack.jak.event.Event __e)
    {
        return __ns.isEnabled() && relevant(((berth.AllocationRequest) __e));
    }
    
    public aos.jack.jak.plan.Plan createPlan(aos.jack.jak.event.Event __e, aos.jack.jak.task.Task __t)
    {
        if (!(__e instanceof berth.AllocationRequest)) 
            return null;
        berth.AllocationRequest __e1 = (berth.AllocationRequest) __e;
        return new berth.AllocateShipNearWantedArrivalTime(__e1,__t,this);
    }
    
    public java.lang.String[] variableNames()
    {
        return __planVariableNames;
    }
    
    public java.lang.String[] variableTypes()
    {
        return __planVariableTypes;
    }
    
    public java.lang.Object getVariable(int n)
    {
        switch (n) {
            case 0: 
            {
                return aos.util.ToObject.box(ev);
            }
            case 1: 
            {
                return aos.util.ToObject.box(self);
            }
            default: 
            {
                throw new java.lang.IndexOutOfBoundsException("Plan " + this + " does not have variable number " + n);
            }
        }
    }
    
    public java.lang.String[] reasoningMethods()
    {
        return mergeReasoningMethods(__reasoningMethods,super.reasoningMethods());
    }
    
    public aos.jack.jak.cursor.Cursor context()
    {
        try {
            return (((true)?aos.jack.jak.cursor.Cursor.trueCursor:aos.jack.jak.cursor.Cursor.falseCursor));
        }
        catch (java.lang.Exception e) {
            e.printStackTrace();
            return aos.jack.jak.cursor.Cursor.falseCursor;
        }
    }
    
    class __bodyFSM extends aos.jack.jak.plan.PlanFSM implements aos.jack.jak.core.Generator {
        java.util.ArrayList __local__2_0;
        com.domainlanguage.time.TimePoint __local__2_1;
        com.domainlanguage.time.Duration __local__2_2;
        com.domainlanguage.time.TimePoint __local__2_3;
        java.util.ArrayList __local__2_4;
        int __local__2_5;
        int __local__2_6;
        boolean __local__2_7;
        gui.Ship __local__2_8;
        boolean __local__2_9;
        gui.Ship __local__2_10;
        int __local__2_11;
        gui.Ship __local__2_12;
        private int __breakLevel = 0;
        public int run(int __status)
            throws java.lang.Throwable
        {
            do {
                try {
                    if (__tothrow != null) 
                        throw __tothrow;
                    if ((aos.jack.jak.core.Jak.debugging & aos.jack.jak.core.Jak.LOG_PLANS) != 0) 
                        aos.util.logging.LogMsg.log(this,aos.jack.jak.core.Jak.LOG_PLANS,__task + "-AllocateShipNearWantedArrivalTime.body:" + java.lang.Integer.toString(__state));
                    if (__task.nsteps > 0) {
                        __task.nsteps-- ;
                        if (__task.nsteps == 0) 
                            agent.changeFocus();
                    }
                    if (__state < 10) {
                        __status = super.stdrun(berth.AllocateShipNearWantedArrivalTime.this,__status);
                        if (__status != CONTINUE || agent.changing_focus) 
                            return __status;
                        continue;
                    }
                    __curstate = __state;
                    switch (__state) {
                        default: 
                        {
                            aos.jack.jak.core.Jak.error("AllocateShipNearWantedArrivalTime.body: Illegal state");
                            return FAILED_STATE;
                        }
                        //* (65)         ArrayList shipList = self.shipList;
                        case 10: 
                        {
                            __breakLevel = 0;
                            __local__2_0 = self.shipList;
                            __state = 11;
                            break;
                        }
                        //* (67)         if(!shipList.isEmpty()){
                        case 11: 
                        {
                            if (!__local__2_0.isEmpty()) 
                                __state = 12;
                             else 
                                __state = 38;
                            break;
                        }
                        //* (68)             TimePoint wantedArrivalTime = ev.ship.getArrivalTime();
                        case 12: 
                        {
                            __breakLevel = 2;
                            __local__2_1 = ev.ship.getArrivalTime();
                            __state = 13;
                            break;
                        }
                        //* (69)             Duration durationOfCharging = ev.durationOfCharging;
                        case 13: 
                        {
                            __local__2_2 = ev.durationOfCharging;
                            __state = 14;
                            break;
                        }
                        //* (70)             TimePoint wantedDepartureTime = wantedArrivalTime.plus(durationOfCharging); 
                        case 14: 
                        {
                            __local__2_3 = __local__2_1.plus(__local__2_2);
                            __state = 15;
                            break;
                        }
                        //* (71)             ArrayList shipToBeMovedList = new ArrayList();
                        case 15: 
                        {
                            __local__2_4 = new java.util.ArrayList();
                            __state = 16;
                            break;
                        }
                        //* (73)             int wantedIndex=0;
                        case 16: 
                        {
                            __local__2_5 = 0;
                            __state = 17;
                            break;
                        }
                        //* (74)             int i = 0;
                        case 17: 
                        {
                            __local__2_6 = 0;
                            __state = 18;
                            break;
                        }
                        //* (75)             boolean intersectionBetweenShips = false;
                        case 18: 
                        {
                            __local__2_7 = false;
                            __state = 19;
                            break;
                        }
                        //* (76)             while(i < shipList.size() && !intersectionBetweenShips){
                        case 19: 
                        {
                            if (__local__2_6 < __local__2_0.size() && !__local__2_7) 
                                __state = 20;
                             else 
                                __state = 25;
                            break;
                        }
                        //* (77)                 Ship ship = (Ship)shipList.get(i);
                        case 20: 
                        {
                            __breakLevel = 6;
                            __local__2_8 = (gui.Ship) __local__2_0.get(__local__2_6);
                            __state = 21;
                            break;
                        }
                        //* (78)                 if(wantedTimeArrivalOccupied(ship, wantedArrivalTime, wantedDepartureTime)){
                        case 21: 
                        {
                            if (wantedTimeArrivalOccupied(__local__2_8,__local__2_1,__local__2_3)) 
                                __state = 22;
                             else 
                                __state = 24;
                            break;
                        }
                        //* (79)                     wantedIndex = i;
                        case 22: 
                        {
                            __breakLevel = 8;
                            __state = 23;
                            __local__2_5 = __local__2_6;
                            break;
                        }
                        //* (80)                     intersectionBetweenShips = true;
                        case 23: 
                        {
                            __state = 19;
                            __local__2_7 = true;
                            break;
                        }
                        //* (83)                     i++;
                        case 24: 
                        {
                            __breakLevel = 8;
                            __state = 19;
                            __local__2_6++ ;
                            break;
                        }
                        //* (86)         boolean isKnockedOut = ev.ship.isKnockedOut(self.getName());
                        case 25: 
                        {
                            __local__2_9 = ev.ship.isKnockedOut(self.getName());
                            __state = 26;
                            break;
                        }
                        //* (87)              if(intersectionBetweenShips && !isKnockedOut){
                        case 26: 
                        {
                            if (__local__2_7 && !__local__2_9) 
                                __state = 27;
                             else 
                                __state = 37;
                            break;
                        }
                        //* (88)                  Ship shipWanted = (Ship)shipList.get(wantedIndex);
                        case 27: 
                        {
                            __breakLevel = 4;
                            __local__2_10 = (gui.Ship) __local__2_0.get(__local__2_5);
                            __state = 28;
                            break;
                        }
                        //* (89)                  wantedArrivalTime = shipWanted.getDepartureTime();                  
                        case 28: 
                        {
                            __state = 29;
                            __local__2_1 = __local__2_10.getDepartureTime();
                            break;
                        }
                        //* (90)                  wantedIndex+=1;           
                        case 29: 
                        {
                            __state = 30;
                            __local__2_5 += 1;
                            break;
                        }
                        //* (91)                  for(int j = wantedIndex; j < shipList.size(); j++){
                        case 30: 
                        {
                            __local__2_11 = __local__2_5;
                            __state = 31;
                            break;
                        }
                        //* (91)                  for(int j = wantedIndex; j < shipList.size(); j++){
                        case 31: 
                        {
                            if (__local__2_11 < __local__2_0.size()) 
                                __state = 32;
                             else 
                                __state = 36;
                            break;
                        }
                        //* (92)                      Ship ship = (Ship)shipList.get(j);
                        case 32: 
                        {
                            __breakLevel = 8;
                            __local__2_12 = (gui.Ship) __local__2_0.get(__local__2_11);
                            __state = 33;
                            break;
                        }
                        //* (93)                      if(wantedTimeArrivalOccupied(ship, wantedArrivalTime, wantedArrivalTime.plus(durationOfCharging))){
                        case 33: 
                        {
                            if (wantedTimeArrivalOccupied(__local__2_12,__local__2_1,__local__2_1.plus(__local__2_2))) 
                                __state = 34;
                             else 
                                __state = 35;
                            break;
                        }
                        //* (94)                          shipToBeMovedList.add(ship);
                        case 34: 
                        {
                            __breakLevel = 10;
                            if (__local__2_4.add(__local__2_12)) 
                                __state = 35;
                             else 
                                throw planfailed;
                            break;
                        }
                        //* (91)                  for(int j = wantedIndex; j < shipList.size(); j++){
                        case 35: 
                        {
                            __state = 31;
                            __local__2_11++ ;
                            break;
                        }
                        //* (97)              sendCost(wantedArrivalTime, durationOfCharging, wantedIndex, shipToBeMovedList); 
                        case 36: 
                        {
                            __task.push(sendCost(__local__2_1,__local__2_2,__local__2_5,__local__2_4));
                            __state = -__state;
                            __subtask_pass = 38;
                            __subtask_fail = 4;
                            return SUBTASK;
                        }
                        //* (100)                 System.out.println("No bid from AllocateShipNearWantedArrivalTime "+self.getName());
                        case 37: 
                        {
                            __breakLevel = 4;
                            __state = 38;
                            java.lang.System.out.println("No bid from AllocateShipNearWantedArrivalTime " + self.getName());
                            break;
                        }
                        //* (62)     #reasoning method
                        case 38: 
                        {
                            if (__pending == null) 
                                __state = PASSED_STATE;
                            __tothrow = __pending;
                            break;
                        }
                    }
                }
                catch (java.lang.Throwable e) {
                    handleException(e,__exMap_body);
                }
            }
             while (!agent.changing_focus);
            return CONTINUE;
        }
        
        public java.lang.String methodName()
        {
            return "body";
        }
        
        __bodyFSM()
        {
        }
        
        public java.lang.String stateInfo()
        {
            int n = __curstate;
            java.lang.String file = __tt__body[0];
            java.lang.String method = __tt__body[1];
            if (n < 0) 
                n = -n;
            n -= (10 - 2);
            java.lang.String line = (n < 2)?"??":__tt__body[n];
            return file + ":" + line + " " + method + " [" + __curstate + "]";
        }
        
        public java.lang.Object genObject(int __index)
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Object Construction");
            return null;
        }
        
        public aos.jack.jak.cursor.Cursor genCursor(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Cursor Construction");
            return null;
        }
        
        public aos.jack.jak.fsm.FSM genFSM(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal FSM Construction");
            return null;
        }
        
        public boolean testCondition(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal test Construction");
            return false;
        }
        
        public aos.jack.jak.plan.Plan getPlan()
        {
            return berth.AllocateShipNearWantedArrivalTime.this;
        }
        
        protected aos.jack.jak.fsm.FSM fail()
        {
            return getPlan().fail();
        }
        
        protected aos.jack.jak.fsm.FSM pass()
        {
            return getPlan().pass();
        }
        
        public void enter()
        {
            __trace = agent.trace("berth.AllocateShipNearWantedArrivalTime.body");
        }
        
        public java.lang.Object getVariable(int n)
        {
            switch (n) {
                case 0: 
                {
                    return aos.util.ToObject.box(__local__2_0);
                }
                case 1: 
                {
                    return aos.util.ToObject.box(__local__2_1);
                }
                case 2: 
                {
                    return aos.util.ToObject.box(__local__2_2);
                }
                case 3: 
                {
                    return aos.util.ToObject.box(__local__2_3);
                }
                case 4: 
                {
                    return aos.util.ToObject.box(__local__2_4);
                }
                case 5: 
                {
                    return aos.util.ToObject.box(__local__2_5);
                }
                case 6: 
                {
                    return aos.util.ToObject.box(__local__2_6);
                }
                case 7: 
                {
                    return aos.util.ToObject.box(__local__2_7);
                }
                case 8: 
                {
                    return aos.util.ToObject.box(__local__2_8);
                }
                case 9: 
                {
                    return aos.util.ToObject.box(__local__2_9);
                }
                case 10: 
                {
                    return aos.util.ToObject.box(__local__2_10);
                }
                case 11: 
                {
                    return aos.util.ToObject.box(__local__2_11);
                }
                case 12: 
                {
                    return aos.util.ToObject.box(__local__2_12);
                }
                default: 
                {
                    throw new java.lang.IndexOutOfBoundsException("Reasoning Method " + methodName() + " does not have variable number " + n);
                }
            }
        }
        
        public java.lang.String[] variableNames()
        {
            return __fsmVariableNames_body;
        }
        
        public java.lang.String[] variableTypes()
        {
            return __fsmTypes_body;
        }
        
        public java.lang.String[] variableLocalNames()
        {
            return __fsmLocalNames_body;
        }
        
    }
    class __sendCostFSM extends aos.jack.jak.plan.PlanFSM implements aos.jack.jak.core.Generator {
        com.domainlanguage.time.TimePoint arrivalDay;
        com.domainlanguage.time.Duration durationOfCharging;
        int index;
        java.util.ArrayList shipToBeMovedList;
        int __local__3_4;
        berth.Bid __local__3_5;
        private int __breakLevel = 0;
        public int run(int __status)
            throws java.lang.Throwable
        {
            do {
                try {
                    if (__tothrow != null) 
                        throw __tothrow;
                    if ((aos.jack.jak.core.Jak.debugging & aos.jack.jak.core.Jak.LOG_PLANS) != 0) 
                        aos.util.logging.LogMsg.log(this,aos.jack.jak.core.Jak.LOG_PLANS,__task + "-AllocateShipNearWantedArrivalTime.sendCost:" + java.lang.Integer.toString(__state));
                    if (__task.nsteps > 0) {
                        __task.nsteps-- ;
                        if (__task.nsteps == 0) 
                            agent.changeFocus();
                    }
                    if (__state < 10) {
                        __status = super.stdrun(berth.AllocateShipNearWantedArrivalTime.this,__status);
                        if (__status != CONTINUE || agent.changing_focus) 
                            return __status;
                        continue;
                    }
                    __curstate = __state;
                    switch (__state) {
                        default: 
                        {
                            aos.jack.jak.core.Jak.error("AllocateShipNearWantedArrivalTime.sendCost: Illegal state");
                            return FAILED_STATE;
                        }
                        //* (107)         int calculatedCost = self.myCostCalculator.calculateCost(arrivalDay, durationOfCharging, ev.ship);
                        case 10: 
                        {
                            __breakLevel = 0;
                            __local__3_4 = self.myCostCalculator.calculateCost(arrivalDay,durationOfCharging,ev.ship);
                            __state = 11;
                            break;
                        }
                        //* (108)         Bid bid = new Bid(ev.ship, calculatedCost, arrivalDay, arrivalDay.plus(durationOfCharging), index, shipToBeMovedList);
                        case 11: 
                        {
                            __local__3_5 = new berth.Bid(ev.ship,__local__3_4,arrivalDay,arrivalDay.plus(durationOfCharging),index,shipToBeMovedList);
                            __state = 12;
                            break;
                        }
                        //* (109)         self.addBid(bid);
                        case 12: 
                        {
                            __state = 13;
                            self.addBid(__local__3_5);
                            break;
                        }
                        //* (110)         System.out.println("Reply from : "+self.getName()+" with cost "+calculatedCost+" "+ev.ship.getName()+ " at "+arrivalDay.toString()+ "AllocateShipNearWantedArrivalTime");
                        case 13: 
                        {
                            __state = 14;
                            java.lang.System.out.println("Reply from : " + self.getName() + " with cost " + __local__3_4 + " " + ev.ship.getName() + " at " + arrivalDay.toString() + "AllocateShipNearWantedArrivalTime");
                            break;
                        }
                        //* (105)     #reasoning method
                        case 14: 
                        {
                            if (__pending == null) 
                                __state = PASSED_STATE;
                            __tothrow = __pending;
                            break;
                        }
                    }
                }
                catch (java.lang.Throwable e) {
                    handleException(e,__exMap_sendCost);
                }
            }
             while (!agent.changing_focus);
            return CONTINUE;
        }
        
        public java.lang.String methodName()
        {
            return "sendCost";
        }
        
        __sendCostFSM(com.domainlanguage.time.TimePoint arrivalDay, com.domainlanguage.time.Duration durationOfCharging, int index, java.util.ArrayList shipToBeMovedList)
        {
            this.arrivalDay = arrivalDay;
            this.durationOfCharging = durationOfCharging;
            this.index = index;
            this.shipToBeMovedList = shipToBeMovedList;
        }
        
        public java.lang.String stateInfo()
        {
            int n = __curstate;
            java.lang.String file = __tt__sendCost[0];
            java.lang.String method = __tt__sendCost[1];
            if (n < 0) 
                n = -n;
            n -= (10 - 2);
            java.lang.String line = (n < 2)?"??":__tt__sendCost[n];
            return file + ":" + line + " " + method + " [" + __curstate + "]";
        }
        
        public java.lang.Object genObject(int __index)
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Object Construction");
            return null;
        }
        
        public aos.jack.jak.cursor.Cursor genCursor(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Cursor Construction");
            return null;
        }
        
        public aos.jack.jak.fsm.FSM genFSM(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal FSM Construction");
            return null;
        }
        
        public boolean testCondition(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal test Construction");
            return false;
        }
        
        public aos.jack.jak.plan.Plan getPlan()
        {
            return berth.AllocateShipNearWantedArrivalTime.this;
        }
        
        public void enter()
        {
            __trace = agent.trace("berth.AllocateShipNearWantedArrivalTime.sendCost");
        }
        
        public java.lang.Object getVariable(int n)
        {
            switch (n) {
                case 0: 
                {
                    return aos.util.ToObject.box(arrivalDay);
                }
                case 1: 
                {
                    return aos.util.ToObject.box(durationOfCharging);
                }
                case 2: 
                {
                    return aos.util.ToObject.box(index);
                }
                case 3: 
                {
                    return aos.util.ToObject.box(shipToBeMovedList);
                }
                case 4: 
                {
                    return aos.util.ToObject.box(__local__3_4);
                }
                case 5: 
                {
                    return aos.util.ToObject.box(__local__3_5);
                }
                default: 
                {
                    throw new java.lang.IndexOutOfBoundsException("Reasoning Method " + methodName() + " does not have variable number " + n);
                }
            }
        }
        
        public java.lang.String[] variableNames()
        {
            return __fsmVariableNames_sendCost;
        }
        
        public java.lang.String[] variableTypes()
        {
            return __fsmTypes_sendCost;
        }
        
        public java.lang.String[] variableLocalNames()
        {
            return __fsmLocalNames_sendCost;
        }
        
    }
}
