package berth;

























import com.domainlanguage.time.*;












import com.domainlanguage.timeutil.*;












import gui.Ship;












import java.lang.Character;












import java.lang.Integer;












import java.lang.String;












import jettyplanner.BerthRequest;












import java.util.*;












import java.util.Calendar;















/** Class with functionality for calculating cost


  *


  * Contain different methods for calculations, 


  * which functionality is shared among other external entities


  * 


  * @author      Elin Marie Kristensen


  * @author      Mari Torgersrud Haug


  * @version     29.05.2006


  */



















public class CostCalculator{
















    private int delayCost = 40000;












    private int dockingCost = 10000;

























/** Empty constructor


  *


  */





    public CostCalculator(){












    }















/** Method that calculate cost for a ship and a duration


  *


  * @param TimePoint arrivalTime


  * @param Duration durationOfCharging


  * @param Ship ship


  */


 public int calculateCost(TimePoint arrivalTime, Duration durationOfCharging, Ship ship){



















        int delayCost = findDelayCost(arrivalTime, ship);












        int chargingCost = findChargingCost(ship.getArrivalTime(), durationOfCharging);












        int calculatedCost = delayCost + chargingCost;












        return calculatedCost;












    }












    


/** Method that convert a duration into number of hours


  *


  * @param TimePoint startTime


  * @param Duration duration


  * 


  * @return int


  */    







    public int calculateDuration(TimePoint startTime,Duration duration){







        TimePoint endTime = startTime.plus(duration);






        Calendar firstCal = startTime.asJavaCalendar();







        Calendar lastCal = endTime.asJavaCalendar();







        long firstInMilli = firstCal.getTimeInMillis();







        long lastInMilli = lastCal.getTimeInMillis(); 







        long durInMilli = lastInMilli-firstInMilli;







        int milliPerHour = 1000*60*60;







        Long hoursL = new Long(durInMilli/milliPerHour);







        int hours = hoursL.intValue();







        return hours;







    }




















    /**












     * Method that calculate the delay cost, which is a function of the number of days of delay and the delayCost.












     * The delayCost is a constant.












     * 


     * @param Timepoint arrivalDay












     * @param Ship the ship to calculate cost for


     * 


     * @return int delayCost












     */












    












    private int findDelayCost(TimePoint arrivalDay, Ship ship){












        TimePoint arrivalTime = ship.getArrivalTime();












        Duration hoursOfDelay = (arrivalTime.until(arrivalDay)).length();












        int hoursOfDelayInt = calculateDuration(arrivalTime,hoursOfDelay);






        int delayCostFunc = hoursOfDelayInt * delayCost;












        return delayCostFunc;












    }

























    /**












     * Method that calculate charging cost, which is a function of the duration of charging in days and the












     * docking cost. The docking cost is a constant.












     * 


     * @param TimePoint arrivalTime


     * @param Duration duration of charging












     * @return int chargingCost












     */












    












     private int findChargingCost(TimePoint arrivalTime, Duration durationOfCharging){












        int chargingCost = 0;










        int durationHours = calculateDuration(arrivalTime, durationOfCharging);










        chargingCost = durationHours * dockingCost; 












        return chargingCost;












    }












}










