package gui;












import java.io.Serializable;









import com.domainlanguage.time.*;









import java.util.Vector;














/** Ship-object 
 * 
 *A ship-object is instanciated with it's static variables. 
 *A ship-object has several get- and set methods to take care of dynamic
 *variables.
 *
 *@author Mari Torgersrud Haug
 *@author Elin M Kristensen
 *@version 29.05.06
 */
public class Ship implements Serializable{


















    private String name;









    private int length;









    private int width;









    private double draft;









    private int capacity;









    private int numberOfHoles;









    private String product;









    private TimePoint arrivalTime;









    private TimePoint delegatedArrivalTime;






    private TimePoint departureTime;









    private Vector visitedBerth;















   /**
     * The constructor instanciate the agent
     * @param String name
     * @param int length
     * @param int width
     * @param double draft
     * @param int capacity
     * @param int numberOfHoles
     */

    public Ship(String name, int length, int width, double draft, int capacity, int numberOfHoles){









        this.name = name;









        this.length = length;









        this.width = width;









        this.draft = draft;









        this.capacity = capacity;









        this.numberOfHoles = numberOfHoles;









        visitedBerth = new Vector();





    }









    








    /**
     *The method returns the name of the agent
     *@return String agentName
    */
    public String getName(){









        return name;









    }









    









    /**
     *The method returns the length of the ship
     *@return int length
    */
    public int getLength(){









        return length;









    }



















    /**
     *The method returns the width of the ship
     *@return int width
     */
    public int getWidth(){









        return width;









    }










    /**
     *The method returns the draft of the ship
     *@return double draft
     */   









    public double getDraft(){









        return draft;









    }









    









    /**
     *The method returns the capacity of the ship
     *@return int capacity
     */
    public int getCapacity(){









        return capacity;









    }









    









    /**
     *The method returns the ship's amount of holes 
     *@return int numberOfHoles
     */
    public int getNumberOfHoles(){









        return numberOfHoles;









    }









    









    /**
     *The method returns the ship's product
     *@return String product
     */
    public String getProduct(){









        return product;









    }









    
    /**
     *The method sets the dynamic variable product
     *@param String product
     */
    







    public void setProduct(String product){









        this.product = product;









    }









    









    /**
     *The method sets the dynamic variable arrivalTime
     *@param TimePoint arrivalTime
     */
    public void setArrivalTime(TimePoint arrivalTime){









        this.arrivalTime = arrivalTime;









    }









    









    /**
     *The method returns the dynamic variable arrivalTime
     *@return TimePoint arrivalTime
     */
    public TimePoint getArrivalTime(){









        return arrivalTime;









    }









    






     /**
     *The method sets the dynamic variable delegatedArrivalTime
     *@param TimePoint delegatedArrivalTime
     */
    public void setDelegatedArrivalTime(TimePoint delegatedArrivalTime){






        this.delegatedArrivalTime = delegatedArrivalTime;






    }












    /**
     *The method returns the dynamic variable delegatedArrivalTime
     *@return TimePoint delegatedArrivalTime
     */

    public TimePoint getDelegatedArrivalTime(){





        return delegatedArrivalTime;





    }











    








/**
     *The method sets the dynamic variable departureTime
     *@param TimePoint departureTime
     */
    public void setDepartureTime(TimePoint departureTime){









        this.departureTime = departureTime;









    }









    









    /**
     *The method returns the dynamic variable departureTime
     *@return TimePoint departureTime
     */
    public TimePoint getDepartureTime(){









        return departureTime;









    }









    





    /**
     * The method checks if the Ship has been knocked out 
     * from a Berth once before.
     * @param String berthName
     * @param boolean true or false
     */
    public boolean isKnockedOut(String berthName){





        return visitedBerth.contains(berthName); 





    }





    





    /**
     * The method reset all dynamic variables to default
     */
    public void newShip(){





       delegatedArrivalTime=null;




       departureTime = null;




       product = null;



       visitedBerth.clear(); 





    }












    /**
     * The method registrate that the ship has been knocked out from
     * a berth
     * @param String berthName
     */
    public void knockOut(String berthName){






        delegatedArrivalTime=null;






        departureTime = null;






        visitedBerth.add(berthName);





    }






}    



















