package gui;





































































































import javax.swing.*;


















































import java.awt.*;


















































import java.awt.event.*;























import javax.swing.table.*;

















































import java.util.ArrayList;


















































import java.util.Calendar;


















































import com.domainlanguage.time.*;





































































































/** Class for making a panel for display and registration of ship data

  *

  * Creates a table with fields that contain information about ships,

  * and to registrate new information

  * 

  * @author      Elin Marie Kristensen

  * @author      Mari Torgersrud Haug

  * @version     29.05.2006

  */

public class ShipPanel extends JPanel implements FocusListener{


















































    public DefaultTableModel tabModell;

















































    public DefaultTableColumnModel colModell;
















































   









 public ArrayList shipList;






































    JettyWindow window;






































    public JTable shipTable;


































    public JTableHeader header














;


































    

/** Constructor for ShipPanel

  *

  * Creates the layout and components for this window. 

  * 

  * @param JettyWindow a reference to the window this panel is added to

  */






















    public ShipPanel(JettyWindow window){


















































        this.window = window;






































        shipList = new ArrayList();






































        setLayout(new BorderLayout());














































        tabModell = new  DefaultTableModel(7, 7);


















































        colModell = new DefaultTableColumnModel(); 
















































        colModell.setColumnSelectionAllowed(false); 
























































       











        shipTable = new JTable(tabModell, colModell);







































        shipTable.setRowSelectionAllowed(false);







































        shipTable.setRowHeight(18);










        makeColumns();


































        add(header, BorderLayout.NORTH);


































        add(shipTable, BorderLayout.WEST);














































    }


















































    

/** Method that makes the columns in this panels table

  *

  * The method specify the component type for each column in this panels tabel,

  * and add it to the tableModell 

  * 

  */ 

 


















































    public void makeColumns(){




























































        JTextField staticField = new JTextField();














































        staticField.setEditable(false);














































        DefaultCellEditor staticEditor = new DefaultCellEditor(staticField); 














































        














































        TableColumn col0 = new TableColumn(0); 

















































        col0.setHeaderValue("ShipName"); 














































        col0.setCellEditor(staticEditor);














































        col0.sizeWidthToFit(); 


































        colModell.addColumn(col0); 














































        














































        TableColumn col1 = new TableColumn(1); 
















































        col1.setCellEditor(staticEditor); 














































        col1.setHeaderValue("Capacity"); 














































        col1.sizeWidthToFit(); 


































        colModell.addColumn(col1);





























































































        TableColumn col2 = new TableColumn(2); 
















































        col2.setCellEditor(staticEditor); 














































        col2.setHeaderValue("# of Holes"); 














































        col2.sizeWidthToFit(); 


































        colModell.addColumn(col2);














































        














































        JTextField timeField = new JTextField();



































        timeField.setEditable(false);



































        DefaultCellEditor timeEditor = new DefaultCellEditor(timeField); 



































        



































        TableColumn col5 = new TableColumn(3); 



































        col5.setHeaderValue("Arrival time"); 



































        col5.setCellEditor(timeEditor); 



































        col5.setPreferredWidth(100); 




























        colModell.addColumn(col5); 




















        


















        JTextField editField = new JTextField();


















        editField.setEditable(true);


















        editField.addFocusListener(this);


















        DefaultCellEditor editEditor = new DefaultCellEditor(editField); 


















        











        TableColumn col3 = new TableColumn(4); 


























        col3.setHeaderValue("Product"); 




















        col3.setPreferredWidth(100); 










        colModell.addColumn(col3);














        











        String[] productValues = new String[]{"diesel","petrolium", "LPG","crude oil","gas oil", "sulphur", "coke"};











        col3.setCellEditor(new ComboEditor(productValues));











        col3.setCellRenderer(new ComboRenderer(productValues));







































        TableColumn col4 = new TableColumn(5); 


























        col4.setHeaderValue("Hours to arrival"); 


























        col4.setPreferredWidth(100);























        col4.setCellEditor(editEditor);        


























        colModell.addColumn(col4); 


























       


























        TableColumn col6 = new TableColumn(6);


























        col6.setIdentifier("Button");  


























        col6.setHeaderValue("Button"); 


























        colModell.addColumn(col6);  


























        col6.setCellRenderer(new SubmitRenderer());


























        col6.setCellEditor(new SubmitEditor(new JCheckBox(), this));





















































        header = new JTableHeader(colModell);


































        DefaultTableCellRenderer headReenderer = new DefaultTableCellRenderer()











;


































        headReenderer.setForeground(shipTable.getForeground());


































        headReenderer.setBackground(Color.lightGray); 


































        headReenderer.setOpaque(true);


































        header.setDefaultRenderer(headReenderer)
;













































        header.setTable(shipTable); 


































        shipTable.setTableHeader(header);


































   }














































   














































/** Method that display information about ship in the fields

  *

  * The method has a list with ship as input, it extract information about this ships, and make

  * it visible in the table. Each ship is represented with a row in the table

  * 

  * @param ArrayList shipList

  */ 

    public void makeShipRows(ArrayList shipList){

















































        this.shipList = shipList;






































        for(int i = 0;i<shipList.size();i++){

















































            Ship ship = (Ship)shipList.get(i);

















































            String shipName = ship.getName();

















































            int shipCapacity = ship.getCapacity();

















































            int numberOfHoles = ship.getNumberOfHoles();
















































            TimePoint arrivalTime = ship.getDelegatedArrivalTime();



































            tabModell.setValueAt(shipName, i, 0); 
















































            tabModell.setValueAt(""+shipCapacity, i, 1); 
















































            tabModell.setValueAt(""+numberOfHoles, i, 2); 









































            tabModell.setValueAt(new Integer(i), i, 6); 



































            if(arrivalTime!=null){









































                tabModell.setValueAt(makeTimeString(arrivalTime), i, 3); 



































            }else{



































                tabModell.setValueAt("no arrival", i, 3); 



































            }



































        }



        setVisible(true);









































    }
















































/** Method that convert a TimePoint into a String

  *

  * This method convert a TimePoint into a String, with this representation: yyyy.mm.dd hh:mm

  * 

  * @param TimePoint timePoint

  */ 

    public String makeTimeString(TimePoint timePoint){





























         TimePoint timePointJust = timePoint.plus(Duration.hours(2));



         Calendar cal = timePointJust.asJavaCalendar();





























         int year = cal.get(Calendar.YEAR);





























         int month = cal.get(Calendar.MONTH) + 1;





























         int date = cal.get(Calendar.DATE);





























         int hour = cal.get(Calendar.HOUR_OF_DAY);





























         int minute = cal.get(Calendar.MINUTE);





























         String s = ""+year + "."+ month + "." + date+"  "+hour+":"+minute;





























         return s;





























    }





























    

/** Method that handles a new registration

 * 

 * This method is used, when there is registrated new input in the panel

 * The method validate what kind of action this should result in, 

 * and call the right methods in the JettyWindow

 * 

 * @param int i row number for the ship

 */ 














































    public void updateShip(int i){






































        Ship ship = (Ship)shipList.get(i);

















        String product = tabModell.getValueAt(i,4).toString();






































        String hourString = tabModell.getValueAt(i,5).toString();






































        int hours = 0;

















        try{

















            hours = Integer.parseInt(hourString);



































            














if(ship.getProduct()!=null){

























                ship.setProduct(product);

























                window.mooveShip(ship, hours);

























            }

























            else




 {
























                ship.setProduct(product);

























                window.submitShip(ship, hours);





























            }










        }catch(NumberFormatException e){










            window.message("Wrong input.");










        }










    }
















































/** Method that resets the fields related to a ship

 * 

 * This method is used, when there has occured something wrong about the registration

 * and the information is no longer valid in relation to the rest of the application

 * 

 * @param Ship retryShip 

 */ 









 public void resetShip(Ship retryShip){










        for(int i = 0;i<shipList.size();i++){










             Ship ship = (Ship)shipList.get(i);










             if(retryShip.getName().equals(ship.getName())){










                 shipList.set(i,retryShip);









                }










        }










    }












/** Method to receive information computed in the program

 * 

 * This method is used, when the program has computed information about a ship,

 * which should be displayed. An update.

 * 

 */    



































   public void receiveShip(){



































        makeShipRows(shipList);



































   }







/** Method to be implemented in accordance to the FocusListener interface

 * 

 * This method is called when a field ha gained focus.

 * It is implemented to select everything inside a textField, when it get focus.

 * 

 * @FocusEvent e

 * 

 */      























   public void focusGained(FocusEvent e){























        Component c = e.getComponent();























        if (c instanceof JTextField) {























            ((JTextField)c).selectAll();























        }























    }























/** Method to be implemented in accordance to the FocusListener interface

 * 

 * Not implemented here

 * 

 * @FocusEvent e

 * 

 */        























    public void focusLost(FocusEvent e) {























    } //ignore















































    





























}











































































































































