package jettyplanner;



















import berth.Bid;












import gui.Ship;
















import java.io.Serializable;















/** Class that represent an alternative allocation of a Ship to a Berth 

  *

  * This class contains get methods for the variables

  *

  * @author      Elin Marie Kristensen

  * @author      Mari Torgersrud Haug

  * @version     18.05.2006

  */





















public class BerthAlternative implements Serializable{

















    String berthName;
















    Ship ship;
















    int cost;









    Bid bid;









  

















  /** Constructor that set the name of a Berth and Bid from the Berth

    *

    * @param   berthName name of the berth contained in this alternative

    * @param   bid the bid for the berth on a ship

    * @see     Bid

    */



    public BerthAlternative(String berthName, Bid bid){









        this.berthName = berthName;
















        this.bid = bid;





    }









    

  /** Get method for the Berths name

    *

    * @return  berth name

    * @see     String

    */








    public String getBerthName(){














        return berthName;









    }









    











  /** Get method for the Ship
 variable
    *

    * @return  a ahip object

    * @see     Ship

    */

    public Ship getShip(){
















        return bid.getShip();
















    }











  /** Get method for the calculatedCost

   * 

   * The cost is calculated when a Berth checks for allocation on a Ship, and come up with a Bid.

   *

   * @return  calculated cost value

   */










  

    public int getCost(){















        return bid.getCalculatedCost();









    }





   /** Get method for the Bid in this alternative

   * 

   * The Bid is sendt from the Berth with relevant parameters after checking allocation possibilities
   *

   * @return this class Bid object

   * @see Bid

   */

  





    public Bid getBid(){





        return bid;





    }















   /** Method that makes a String representation of this Object

   * 

   * @return a String representation for this Object

   * @see String

   */   








    public String toString(){








        return "BerthAlternative: "+"ship: "+getShip().getName()+" berth: "+getBerthName()+" cost: "+getCost();








    }








    


















}