/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  This code is generated by JAC version 5.0 by
  Agent Oriented Software. http://www.agent-software.com.au

    DO NOT ALTER THIS CODE AND DO NOT REMOVE THIS COMMENT
 *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
package jettyplanner;
import aos.jack.jak.plan.Plan;
import aos.jack.jak.plan.PlanFSM;
import aos.jack.jak.plan.ExMap;
import aos.jack.jak.agent.NameSpace;
import aos.jack.jak.event.Event;
import aos.jack.jak.task.Task;
import aos.jack.jak.core.Generator;
import aos.jack.jak.logic.Signature;
import berth.DisplayShip;
import aos.jack.util.thread.Semaphore;
import java.util.ArrayList;
import berth.Bid;
import aos.jack.jak.cursor.Cursor;
import aos.jack.jak.fsm.FSM;
import aos.jack.jak.core.Jak;
import gui.Ship;

/**Plan ChooseBestBerthAlternative
 * 
 * This plan chooses the best berth alternative from a list when a ship 
 * need a berth allocation. A delegateResponsibilty event is sent to the berth with
 * the best offer.
 * 
 * @author Mari Torgersrud Haug
 * @author Elin M Kristensen
 * @version 29.05.06
 * 
 * @see BerthAlternative
 * @see BerthAlternatives
 * @see DelegationOfResponsibility
 * @see DisplayShip
 */

public class ChooseBerthAlternative extends aos.jack.jak.plan.Plan {
    jettyplanner.BerthAlternative bestAlternative;
    public jettyplanner.BerthAlternatives baEv;
    public jettyplanner.DelegationOfResponsibility dorEv;
    public berth.DisplayShip dispEv;
    public jettyplanner.JettyPlanner self;
    public aos.jack.util.thread.Semaphore semaphore;
    private static aos.jack.jak.plan.ExMap[] __exMap_body;
    private static java.lang.String[] __tt__body = {
            "jettyplanner/ChooseBerthAlternative.plan",
            "body",
            "51",
            "52",
            "53",
            "54",
            "55",
            "56",
            "57",
            "58",
            "60",
            "61",
            "63",
            "64",
            "48"};
    private static aos.jack.jak.plan.ExMap[] __exMap_delegateToBerth;
    private static java.lang.String[] __tt__delegateToBerth = {
            "jettyplanner/ChooseBerthAlternative.plan",
            "delegateToBerth",
            "69",
            "70",
            "67"};
    private static aos.jack.jak.plan.ExMap[] __exMap_findBestAlternative;
    private static java.lang.String[] __tt__findBestAlternative = {
            "jettyplanner/ChooseBerthAlternative.plan",
            "findBestAlternative",
            "75",
            "76",
            "77",
            "78",
            "78",
            "79",
            "80",
            "81",
            "82",
            "78",
            "87",
            "88",
            "90",
            "90",
            "73"};
    private final static java.lang.String[] __planVariableNames = {
            "bestAlternative",
            "baEv",
            "dorEv",
            "dispEv",
            "self",
            "semaphore"};
    private final static java.lang.String[] __planVariableTypes = {
            "jettyplanner.BerthAlternative",
            "jettyplanner.BerthAlternatives",
            "jettyplanner.DelegationOfResponsibility",
            "DisplayShip",
            "JettyPlanner",
            "aos.jack.util.thread.Semaphore"};
    private final static java.lang.String[] __reasoningMethods = {
            "body",
            "findBestAlternative",
            "delegateToBerth"};
    private final static java.lang.String[] __fsmVariableNames_body = {
            "bestBid",
            "delegatedBerth",
            "retryShip"};
    private final static java.lang.String[] __fsmTypes_body = {
            "Bid",
            "String",
            "Ship"};
    private final static java.lang.String[] __fsmLocalNames_body = {
            "__local__15_0",
            "__local__15_1",
            "__local__15_2"};
    private final static java.lang.String[] __fsmVariableNames_delegateToBerth = {
            "berthName",
            "bid",
            "tempDorEv"};
    private final static java.lang.String[] __fsmTypes_delegateToBerth = {
            "String",
            "Bid",
            "DelegationOfResponsibility"};
    private final static java.lang.String[] __fsmLocalNames_delegateToBerth = {
            "berthName",
            "bid",
            "__local__16_2"};
    private final static java.lang.String[] __fsmVariableNames_findBestAlternative = {
            "altList",
            "cost",
            "i",
            "tempAlt"};
    private final static java.lang.String[] __fsmTypes_findBestAlternative = {
            "ArrayList",
            "int",
            "int",
            "BerthAlternative"};
    private final static java.lang.String[] __fsmLocalNames_findBestAlternative = {
            "altList",
            "__local__17_1",
            "__local__17_2",
            "__local__17_3"};
    static boolean relevant(jettyplanner.BerthAlternatives baEv)
    {
        return true;
    }
    
    public java.lang.String getDocumentation()
    {
        return "/**Plan ChooseBestBerthAlternative\n * \n * This plan chooses the best berth alternative from a list when a ship \n * need a berth allocation. A delegateResponsibilty event is sent to the berth with\n * the best offer.\n * \n * @author Mari Torgersrud Haug\n * @author Elin M Kristensen\n * @version 29.05.06\n * \n * @see BerthAlternative\n * @see BerthAlternatives\n * @see DelegationOfResponsibility\n * @see DisplayShip\n */\n";
    }
    
    public ChooseBerthAlternative()
    {
    }
    
    private ChooseBerthAlternative(aos.jack.jak.task.Task __t, jettyplanner.ChooseBerthAlternative __env)
    {
        __agent = __env.__agent;
        __ns = __env.__ns;
        __planTask = __t;
        __logic = __t.logic;
        baEv = __env.baEv;
        dorEv = __env.dorEv;
        dispEv = __env.dispEv;
        self = (jettyplanner.JettyPlanner) __ns.getIF(jettyplanner.JettyPlanner.class);
        semaphore = __env.semaphore;
    }
    
    public boolean init_sentinel(aos.jack.jak.agent.NameSpace __a)
    {
        baEv = (jettyplanner.BerthAlternatives) __a.findEvent("jettyplanner.BerthAlternatives");
        if (baEv == null) {
            warning("Failed to find BerthAlternatives baEv");
            return false;
        }
        dorEv = (jettyplanner.DelegationOfResponsibility) __a.findEvent("jettyplanner.DelegationOfResponsibility");
        if (dorEv == null) {
            warning("Failed to find DelegationOfResponsibility dorEv");
            return false;
        }
        dispEv = (berth.DisplayShip) __a.findEvent("berth.DisplayShip");
        if (dispEv == null) {
            warning("Failed to find DisplayShip dispEv");
            return false;
        }
        semaphore = (aos.jack.util.thread.Semaphore) lookupNamedObject("semaphore","aos.jack.util.thread.Semaphore",0);
        if (semaphore == null) {
            warning("Failed to find Semaphore semaphore");
            return false;
        }
        return true;
    }
    
    public aos.jack.jak.plan.Plan freeze()
    {
        return this;
    }
    
    public aos.jack.jak.plan.Plan unfreeze()
    {
        return this;
    }
    
    public java.lang.Object genObject(int __index)
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Object Construction");
        return null;
    }
    
    public aos.jack.jak.cursor.Cursor genCursor(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Cursor Construction");
        return null;
    }
    
    public aos.jack.jak.fsm.FSM genFSM(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal FSM Construction");
        return null;
    }
    
    public boolean testCondition(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal test Construction");
        return false;
    }
    
    public aos.jack.jak.plan.PlanFSM body()
    {
        return new jettyplanner.ChooseBerthAlternative.__bodyFSM();
    }
    
    public aos.jack.jak.plan.PlanFSM delegateToBerth(java.lang.String berthName, berth.Bid bid)
    {
        return new jettyplanner.ChooseBerthAlternative.__delegateToBerthFSM(berthName,bid);
    }
    
    public aos.jack.jak.plan.PlanFSM findBestAlternative(java.util.ArrayList altList)
    {
        return new jettyplanner.ChooseBerthAlternative.__findBestAlternativeFSM(altList);
    }
    
    private ChooseBerthAlternative(jettyplanner.BerthAlternatives __ev, aos.jack.jak.task.Task __t, jettyplanner.ChooseBerthAlternative __env)
    {
        this(__t,__env);
        this.baEv = __ev;
    }
    
    protected aos.jack.jak.logic.Signature eventSignature(int __log)
    {
        return baEv.getSignature(__log);
    }
    
    public java.lang.String handledEvent()
    {
        return "jettyplanner.BerthAlternatives";
    }
    
    public boolean __relevant(aos.jack.jak.event.Event __e)
    {
        return __ns.isEnabled() && relevant(((jettyplanner.BerthAlternatives) __e));
    }
    
    public aos.jack.jak.plan.Plan createPlan(aos.jack.jak.event.Event __e, aos.jack.jak.task.Task __t)
    {
        if (!(__e instanceof jettyplanner.BerthAlternatives)) 
            return null;
        jettyplanner.BerthAlternatives __e1 = (jettyplanner.BerthAlternatives) __e;
        return new jettyplanner.ChooseBerthAlternative(__e1,__t,this);
    }
    
    public java.lang.String[] variableNames()
    {
        return __planVariableNames;
    }
    
    public java.lang.String[] variableTypes()
    {
        return __planVariableTypes;
    }
    
    public java.lang.Object getVariable(int n)
    {
        switch (n) {
            case 0: 
            {
                return aos.util.ToObject.box(bestAlternative);
            }
            case 1: 
            {
                return aos.util.ToObject.box(baEv);
            }
            case 2: 
            {
                return aos.util.ToObject.box(dorEv);
            }
            case 3: 
            {
                return aos.util.ToObject.box(dispEv);
            }
            case 4: 
            {
                return aos.util.ToObject.box(self);
            }
            case 5: 
            {
                return aos.util.ToObject.box(semaphore);
            }
            default: 
            {
                throw new java.lang.IndexOutOfBoundsException("Plan " + this + " does not have variable number " + n);
            }
        }
    }
    
    public java.lang.String[] reasoningMethods()
    {
        return mergeReasoningMethods(__reasoningMethods,super.reasoningMethods());
    }
    
    public aos.jack.jak.cursor.Cursor context()
    {
        try {
            return (((true)?aos.jack.jak.cursor.Cursor.trueCursor:aos.jack.jak.cursor.Cursor.falseCursor));
        }
        catch (java.lang.Exception e) {
            e.printStackTrace();
            return aos.jack.jak.cursor.Cursor.falseCursor;
        }
    }
    
    class __bodyFSM extends aos.jack.jak.plan.PlanFSM implements aos.jack.jak.core.Generator {
        berth.Bid __local__15_0;
        java.lang.String __local__15_1;
        gui.Ship __local__15_2;
        private int __breakLevel = 0;
        public int run(int __status)
            throws java.lang.Throwable
        {
            do {
                try {
                    if (__tothrow != null) 
                        throw __tothrow;
                    if ((aos.jack.jak.core.Jak.debugging & aos.jack.jak.core.Jak.LOG_PLANS) != 0) 
                        aos.util.logging.LogMsg.log(this,aos.jack.jak.core.Jak.LOG_PLANS,__task + "-ChooseBerthAlternative.body:" + java.lang.Integer.toString(__state));
                    if (__task.nsteps > 0) {
                        __task.nsteps-- ;
                        if (__task.nsteps == 0) 
                            agent.changeFocus();
                    }
                    if (__state < 10) {
                        __status = super.stdrun(jettyplanner.ChooseBerthAlternative.this,__status);
                        if (__status != CONTINUE || agent.changing_focus) 
                            return __status;
                        continue;
                    }
                    __curstate = __state;
                    switch (__state) {
                        default: 
                        {
                            aos.jack.jak.core.Jak.error("ChooseBerthAlternative.body: Illegal state");
                            return FAILED_STATE;
                        }
                        //* (51)         System.out.println("Number of alternatives is: "+baEv.berthAlternatives.size());
                        case 10: 
                        {
                            __breakLevel = 0;
                            __state = 11;
                            java.lang.System.out.println("Number of alternatives is: " + baEv.berthAlternatives.size());
                            break;
                        }
                        //* (52)         findBestAlternative(baEv.berthAlternatives);
                        case 11: 
                        {
                            __task.push(findBestAlternative(baEv.berthAlternatives));
                            __state = -__state;
                            __subtask_pass = 12;
                            __subtask_fail = 4;
                            return SUBTASK;
                        }
                        //* (53)         if(bestAlternative!=null){
                        case 12: 
                        {
                            if (bestAlternative != null) 
                                __state = 13;
                             else 
                                __state = 18;
                            break;
                        }
                        //* (54)             System.out.println("Best alternative:");
                        case 13: 
                        {
                            __breakLevel = 2;
                            __state = 14;
                            java.lang.System.out.println("Best alternative:");
                            break;
                        }
                        //* (55)             Bid bestBid = bestAlternative.getBid();
                        case 14: 
                        {
                            __local__15_0 = bestAlternative.getBid();
                            __state = 15;
                            break;
                        }
                        //* (56)             bestBid.updateShipTime();
                        case 15: 
                        {
                            __state = 16;
                            __local__15_0.updateShipTime();
                            break;
                        }
                        //* (57)             String delegatedBerth = bestAlternative.getBerthName();
                        case 16: 
                        {
                            __local__15_1 = bestAlternative.getBerthName();
                            __state = 17;
                            break;
                        }
                        //* (58)             delegateToBerth(delegatedBerth, bestBid);
                        case 17: 
                        {
                            __task.push(delegateToBerth(__local__15_1,__local__15_0));
                            __state = -__state;
                            __subtask_pass = 20;
                            __subtask_fail = 4;
                            return SUBTASK;
                        }
                        //* (60)              Ship retryShip = baEv.retryShip;
                        case 18: 
                        {
                            __breakLevel = 2;
                            __local__15_2 = baEv.retryShip;
                            __state = 19;
                            break;
                        }
                        //* (61)              @send("GUIAgent", dispEv.display(100,retryShip));
                        case 19: 
                        {
                            __state = 20;
                            agent.send("GUIAgent",dispEv.display(100,__local__15_2));
                            break;
                        }
                        //* (63)         System.out.println("JETTYPLANNER FINISHED WITH SHIP");
                        case 20: 
                        {
                            __state = 21;
                            java.lang.System.out.println("JETTYPLANNER FINISHED WITH SHIP");
                            break;
                        }
                        //* (64)         semaphore.signal(); 
                        case 21: 
                        {
                            __state = 22;
                            semaphore.signal();
                            break;
                        }
                        //* (48)     #reasoning method
                        case 22: 
                        {
                            if (__pending == null) 
                                __state = PASSED_STATE;
                            __tothrow = __pending;
                            break;
                        }
                    }
                }
                catch (java.lang.Throwable e) {
                    handleException(e,__exMap_body);
                }
            }
             while (!agent.changing_focus);
            return CONTINUE;
        }
        
        public java.lang.String methodName()
        {
            return "body";
        }
        
        __bodyFSM()
        {
        }
        
        public java.lang.String stateInfo()
        {
            int n = __curstate;
            java.lang.String file = __tt__body[0];
            java.lang.String method = __tt__body[1];
            if (n < 0) 
                n = -n;
            n -= (10 - 2);
            java.lang.String line = (n < 2)?"??":__tt__body[n];
            return file + ":" + line + " " + method + " [" + __curstate + "]";
        }
        
        public java.lang.Object genObject(int __index)
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Object Construction");
            return null;
        }
        
        public aos.jack.jak.cursor.Cursor genCursor(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Cursor Construction");
            return null;
        }
        
        public aos.jack.jak.fsm.FSM genFSM(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal FSM Construction");
            return null;
        }
        
        public boolean testCondition(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal test Construction");
            return false;
        }
        
        public aos.jack.jak.plan.Plan getPlan()
        {
            return jettyplanner.ChooseBerthAlternative.this;
        }
        
        protected aos.jack.jak.fsm.FSM fail()
        {
            return getPlan().fail();
        }
        
        protected aos.jack.jak.fsm.FSM pass()
        {
            return getPlan().pass();
        }
        
        public void enter()
        {
            __trace = agent.trace("jettyplanner.ChooseBerthAlternative.body");
        }
        
        public java.lang.Object getVariable(int n)
        {
            switch (n) {
                case 0: 
                {
                    return aos.util.ToObject.box(__local__15_0);
                }
                case 1: 
                {
                    return aos.util.ToObject.box(__local__15_1);
                }
                case 2: 
                {
                    return aos.util.ToObject.box(__local__15_2);
                }
                default: 
                {
                    throw new java.lang.IndexOutOfBoundsException("Reasoning Method " + methodName() + " does not have variable number " + n);
                }
            }
        }
        
        public java.lang.String[] variableNames()
        {
            return __fsmVariableNames_body;
        }
        
        public java.lang.String[] variableTypes()
        {
            return __fsmTypes_body;
        }
        
        public java.lang.String[] variableLocalNames()
        {
            return __fsmLocalNames_body;
        }
        
    }
    class __delegateToBerthFSM extends aos.jack.jak.plan.PlanFSM implements aos.jack.jak.core.Generator {
        java.lang.String berthName;
        berth.Bid bid;
        jettyplanner.DelegationOfResponsibility __local__16_2;
        private int __breakLevel = 0;
        public int run(int __status)
            throws java.lang.Throwable
        {
            do {
                try {
                    if (__tothrow != null) 
                        throw __tothrow;
                    if ((aos.jack.jak.core.Jak.debugging & aos.jack.jak.core.Jak.LOG_PLANS) != 0) 
                        aos.util.logging.LogMsg.log(this,aos.jack.jak.core.Jak.LOG_PLANS,__task + "-ChooseBerthAlternative.delegateToBerth:" + java.lang.Integer.toString(__state));
                    if (__task.nsteps > 0) {
                        __task.nsteps-- ;
                        if (__task.nsteps == 0) 
                            agent.changeFocus();
                    }
                    if (__state < 10) {
                        __status = super.stdrun(jettyplanner.ChooseBerthAlternative.this,__status);
                        if (__status != CONTINUE || agent.changing_focus) 
                            return __status;
                        continue;
                    }
                    __curstate = __state;
                    switch (__state) {
                        default: 
                        {
                            aos.jack.jak.core.Jak.error("ChooseBerthAlternative.delegateToBerth: Illegal state");
                            return FAILED_STATE;
                        }
                        //* (69)         DelegationOfResponsibility tempDorEv = dorEv.delegate(bid);   
                        case 10: 
                        {
                            __breakLevel = 0;
                            __local__16_2 = dorEv.delegate(bid);
                            __state = 11;
                            break;
                        }
                        //* (70)         @send(berthName, tempDorEv);
                        case 11: 
                        {
                            __state = 12;
                            agent.send(berthName,__local__16_2);
                            break;
                        }
                        //* (67)     #reasoning method
                        case 12: 
                        {
                            if (__pending == null) 
                                __state = PASSED_STATE;
                            __tothrow = __pending;
                            break;
                        }
                    }
                }
                catch (java.lang.Throwable e) {
                    handleException(e,__exMap_delegateToBerth);
                }
            }
             while (!agent.changing_focus);
            return CONTINUE;
        }
        
        public java.lang.String methodName()
        {
            return "delegateToBerth";
        }
        
        __delegateToBerthFSM(java.lang.String berthName, berth.Bid bid)
        {
            this.berthName = berthName;
            this.bid = bid;
        }
        
        public java.lang.String stateInfo()
        {
            int n = __curstate;
            java.lang.String file = __tt__delegateToBerth[0];
            java.lang.String method = __tt__delegateToBerth[1];
            if (n < 0) 
                n = -n;
            n -= (10 - 2);
            java.lang.String line = (n < 2)?"??":__tt__delegateToBerth[n];
            return file + ":" + line + " " + method + " [" + __curstate + "]";
        }
        
        public java.lang.Object genObject(int __index)
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Object Construction");
            return null;
        }
        
        public aos.jack.jak.cursor.Cursor genCursor(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Cursor Construction");
            return null;
        }
        
        public aos.jack.jak.fsm.FSM genFSM(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal FSM Construction");
            return null;
        }
        
        public boolean testCondition(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal test Construction");
            return false;
        }
        
        public aos.jack.jak.plan.Plan getPlan()
        {
            return jettyplanner.ChooseBerthAlternative.this;
        }
        
        public void enter()
        {
            __trace = agent.trace("jettyplanner.ChooseBerthAlternative.delegateToBerth");
        }
        
        public java.lang.Object getVariable(int n)
        {
            switch (n) {
                case 0: 
                {
                    return aos.util.ToObject.box(berthName);
                }
                case 1: 
                {
                    return aos.util.ToObject.box(bid);
                }
                case 2: 
                {
                    return aos.util.ToObject.box(__local__16_2);
                }
                default: 
                {
                    throw new java.lang.IndexOutOfBoundsException("Reasoning Method " + methodName() + " does not have variable number " + n);
                }
            }
        }
        
        public java.lang.String[] variableNames()
        {
            return __fsmVariableNames_delegateToBerth;
        }
        
        public java.lang.String[] variableTypes()
        {
            return __fsmTypes_delegateToBerth;
        }
        
        public java.lang.String[] variableLocalNames()
        {
            return __fsmLocalNames_delegateToBerth;
        }
        
    }
    class __findBestAlternativeFSM extends aos.jack.jak.plan.PlanFSM implements aos.jack.jak.core.Generator {
        java.util.ArrayList altList;
        int __local__17_1;
        int __local__17_2;
        jettyplanner.BerthAlternative __local__17_3;
        private int __breakLevel = 0;
        public int run(int __status)
            throws java.lang.Throwable
        {
            do {
                try {
                    if (__tothrow != null) 
                        throw __tothrow;
                    if ((aos.jack.jak.core.Jak.debugging & aos.jack.jak.core.Jak.LOG_PLANS) != 0) 
                        aos.util.logging.LogMsg.log(this,aos.jack.jak.core.Jak.LOG_PLANS,__task + "-ChooseBerthAlternative.findBestAlternative:" + java.lang.Integer.toString(__state));
                    if (__task.nsteps > 0) {
                        __task.nsteps-- ;
                        if (__task.nsteps == 0) 
                            agent.changeFocus();
                    }
                    if (__state < 10) {
                        __status = super.stdrun(jettyplanner.ChooseBerthAlternative.this,__status);
                        if (__status != CONTINUE || agent.changing_focus) 
                            return __status;
                        continue;
                    }
                    __curstate = __state;
                    switch (__state) {
                        default: 
                        {
                            aos.jack.jak.core.Jak.error("ChooseBerthAlternative.findBestAlternative: Illegal state");
                            return FAILED_STATE;
                        }
                        //* (75)         if(!altList.isEmpty()){
                        case 10: 
                        {
                            __breakLevel = 0;
                            if (!altList.isEmpty()) 
                                __state = 11;
                             else 
                                __state = 20;
                            break;
                        }
                        //* (76)             bestAlternative = (BerthAlternative)altList.get(0);
                        case 11: 
                        {
                            __breakLevel = 2;
                            __state = 12;
                            bestAlternative = (jettyplanner.BerthAlternative) altList.get(0);
                            break;
                        }
                        //* (77)             int cost = bestAlternative.getCost();
                        case 12: 
                        {
                            __local__17_1 = bestAlternative.getCost();
                            __state = 13;
                            break;
                        }
                        //* (78)             for(int i = 1;i<altList.size();i++){
                        case 13: 
                        {
                            __local__17_2 = 1;
                            __state = 14;
                            break;
                        }
                        //* (78)             for(int i = 1;i<altList.size();i++){
                        case 14: 
                        {
                            if (__local__17_2 < altList.size()) 
                                __state = 15;
                             else 
                                __state = 22;
                            break;
                        }
                        //* (79)                 BerthAlternative tempAlt = (BerthAlternative)altList.get(i);
                        case 15: 
                        {
                            __breakLevel = 6;
                            __local__17_3 = (jettyplanner.BerthAlternative) altList.get(__local__17_2);
                            __state = 16;
                            break;
                        }
                        //* (80)                 if(tempAlt.getCost()<cost){
                        case 16: 
                        {
                            if (__local__17_3.getCost() < __local__17_1) 
                                __state = 17;
                             else 
                                __state = 19;
                            break;
                        }
                        //* (81)                     cost = tempAlt.getCost();
                        case 17: 
                        {
                            __breakLevel = 8;
                            __state = 18;
                            __local__17_1 = __local__17_3.getCost();
                            break;
                        }
                        //* (82)                     bestAlternative = tempAlt;
                        case 18: 
                        {
                            __state = 19;
                            bestAlternative = __local__17_3;
                            break;
                        }
                        //* (78)             for(int i = 1;i<altList.size();i++){
                        case 19: 
                        {
                            __state = 14;
                            __local__17_2++ ;
                            break;
                        }
                        //* (87)             bestAlternative = null;
                        case 20: 
                        {
                            __breakLevel = 2;
                            __state = 21;
                            bestAlternative = null;
                            break;
                        }
                        //* (88)             System.out.println("No alternatives for the ship...");
                        case 21: 
                        {
                            __state = 22;
                            java.lang.System.out.println("No alternatives for the ship...");
                            break;
                        }
                        //* (90)         return true;
                        case 22: 
                        {
                            if (true) 
                                __state = 23;
                             else 
                                throw planfailed;
                            break;
                        }
                        //* (90)         return true;
                        case 23: 
                        {
                            __breakLevel = 0;
                            __state = 24;
                            break;
                        }
                        //* (73)     #reasoning method
                        case 24: 
                        {
                            if (__pending == null) 
                                __state = PASSED_STATE;
                            __tothrow = __pending;
                            break;
                        }
                    }
                }
                catch (java.lang.Throwable e) {
                    handleException(e,__exMap_findBestAlternative);
                }
            }
             while (!agent.changing_focus);
            return CONTINUE;
        }
        
        public java.lang.String methodName()
        {
            return "findBestAlternative";
        }
        
        __findBestAlternativeFSM(java.util.ArrayList altList)
        {
            this.altList = altList;
        }
        
        public java.lang.String stateInfo()
        {
            int n = __curstate;
            java.lang.String file = __tt__findBestAlternative[0];
            java.lang.String method = __tt__findBestAlternative[1];
            if (n < 0) 
                n = -n;
            n -= (10 - 2);
            java.lang.String line = (n < 2)?"??":__tt__findBestAlternative[n];
            return file + ":" + line + " " + method + " [" + __curstate + "]";
        }
        
        public java.lang.Object genObject(int __index)
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Object Construction");
            return null;
        }
        
        public aos.jack.jak.cursor.Cursor genCursor(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Cursor Construction");
            return null;
        }
        
        public aos.jack.jak.fsm.FSM genFSM(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal FSM Construction");
            return null;
        }
        
        public boolean testCondition(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal test Construction");
            return false;
        }
        
        public aos.jack.jak.plan.Plan getPlan()
        {
            return jettyplanner.ChooseBerthAlternative.this;
        }
        
        public void enter()
        {
            __trace = agent.trace("jettyplanner.ChooseBerthAlternative.findBestAlternative");
        }
        
        public java.lang.Object getVariable(int n)
        {
            switch (n) {
                case 0: 
                {
                    return aos.util.ToObject.box(altList);
                }
                case 1: 
                {
                    return aos.util.ToObject.box(__local__17_1);
                }
                case 2: 
                {
                    return aos.util.ToObject.box(__local__17_2);
                }
                case 3: 
                {
                    return aos.util.ToObject.box(__local__17_3);
                }
                default: 
                {
                    throw new java.lang.IndexOutOfBoundsException("Reasoning Method " + methodName() + " does not have variable number " + n);
                }
            }
        }
        
        public java.lang.String[] variableNames()
        {
            return __fsmVariableNames_findBestAlternative;
        }
        
        public java.lang.String[] variableTypes()
        {
            return __fsmTypes_findBestAlternative;
        }
        
        public java.lang.String[] variableLocalNames()
        {
            return __fsmLocalNames_findBestAlternative;
        }
        
    }
}
