/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  This code is generated by JAC version 5.0 by
  Agent Oriented Software. http://www.agent-software.com.au

    DO NOT ALTER THIS CODE AND DO NOT REMOVE THIS COMMENT
 *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
package berth;
import aos.jack.jak.plan.Plan;
import aos.jack.jak.plan.PlanFSM;
import aos.jack.jak.plan.ExMap;
import aos.jack.jak.agent.NameSpace;
import aos.jack.jak.event.Event;
import aos.jack.jak.task.Task;
import aos.jack.jak.core.Generator;
import aos.jack.jak.cursor.Cursor;
import aos.jack.jak.logic.Variable;
import aos.jack.jak.logic.Signature;
import jettyplanner.BerthRequest;
import com.domainlanguage.time.TimePoint;
import com.domainlanguage.time.Duration;
import jettyplanner.BerthAlternative;
import aos.jack.jak.fsm.FSM;
import aos.jack.jak.core.Jak;

/**Plan AllocationCheck
 * 
 * The Berth first check if it has the right product and the rigtht size requested by the ship.
 * Thereafter it calculate the duration of charging and posts an event to find different 
 * allocation alternatives. The reply contains a bid, and the best alternative for this Berth is added
 * in a list. 
 * 
 * @author Mari Torgersrud Haug
 * @author Elin M Kristensen
 * @version 29.05.06
 * 
 * @see AllocationRequest
 * @see BerthRequest
 * @see BerthReply
 * @see MyLiftingArmBs
 */

public class AllocationCheck extends aos.jack.jak.plan.Plan {
    aos.jack.jak.logic.Variable capacity;
    aos.jack.jak.logic.Variable liftingArmId;
    private static java.lang.Class __exClass_0 = aos.jack.jak.fsm.FSM.loadClass("java.lang.Exception");
    public jettyplanner.BerthRequest bRqev;
    public berth.BerthReply bRpev;
    public berth.AllocationRequest aRqev;
    public berth.Berth self;
    public berth.MyLiftingArmBs SingleBerthLiftingArmBs;
    private static aos.jack.jak.plan.ExMap[] __exMap_body = {
            new aos.jack.jak.plan.ExMap(12,14,15,__exClass_0)};
    private static java.lang.String[] __tt__body = {
            "berth/AllocationCheck.plan",
            "body",
            "74",
            "75",
            "77",
            "77",
            "78",
            "81",
            "82",
            "86",
            "71",
            "91",
            "92",
            "94",
            "95",
            "97",
            "98",
            "99",
            "100",
            "101",
            "102",
            "105",
            "107",
            "111",
            "71"};
    private final static java.lang.String[] __planVariableNames = {
            "capacity",
            "liftingArmId",
            "bRqev",
            "bRpev",
            "aRqev",
            "self",
            "SingleBerthLiftingArmBs"};
    private final static java.lang.String[] __planVariableTypes = {
            "logical int",
            "logical String",
            "jettyplanner.BerthRequest",
            "BerthReply",
            "berth.AllocationRequest",
            "berth.Berth",
            "berth.MyLiftingArmBs"};
    private final static java.lang.String[] __reasoningMethods = {
            "body"};
    private final static java.lang.String[] __logSignatureVariableNames = {
            "capacity",
            "liftingArmId"};
    private final static java.lang.String[] __logSignatureVariableTypes = {
            "logical int",
            "logical String"};
    private final static java.lang.String[] __fsmVariableNames_body = {
            "hasProduct",
            "ba",
            "c",
            "e",
            "wantedArrivalTime",
            "durationOfCharging",
            "alreq",
            "bestBid",
            "bid"};
    private final static java.lang.String[] __fsmTypes_body = {
            "boolean",
            "BerthAlternative",
            "Cursor",
            "Exception",
            "TimePoint",
            "Duration",
            "AllocationRequest",
            "Bid",
            "Bid"};
    private final static java.lang.String[] __fsmLocalNames_body = {
            "__local__6_0",
            "__local__6_1",
            "__local__6_2",
            "__local__6_3",
            "__local__6_4",
            "__local__6_5",
            "__local__6_6",
            "__local__6_7",
            "__local__6_8"};
    /**
     *The duration of charging is a function of the ship capacity and the numbers of 
     *liftingarms at the berth.
     *@param Timepoint wantedArrivalTime
     *@return Duration durationOfCharging
     */

    private com.domainlanguage.time.Duration findDurationOfCharging(com.domainlanguage.time.TimePoint wantedArrivalTime)
    {
        int totalLiftingArmCapacity = self.findTotLACapacity(bRqev.product);
        java.lang.Double duration;
        try {
            duration = new java.lang.Double(bRqev.capacity / totalLiftingArmCapacity);
        }
        catch (java.lang.ArithmeticException e) {
            duration = new java.lang.Double(0.0);
        }
        com.domainlanguage.time.Duration durationOfCharging = com.domainlanguage.time.Duration.hours(duration.intValue());
        return durationOfCharging;
    }
    
    static boolean relevant(jettyplanner.BerthRequest ev)
    {
        return true;
    }
    
    public java.lang.String getDocumentation()
    {
        return "/**Plan AllocationCheck\n * \n * The Berth first check if it has the right product and the rigtht size requested by the ship.\n * Thereafter it calculate the duration of charging and posts an event to find different \n * allocation alternatives. The reply contains a bid, and the best alternative for this Berth is added\n * in a list. \n * \n * @author Mari Torgersrud Haug\n * @author Elin M Kristensen\n * @version 29.05.06\n * \n * @see AllocationRequest\n * @see BerthRequest\n * @see BerthReply\n * @see MyLiftingArmBs\n */\n";
    }
    
    public AllocationCheck()
    {
    }
    
    private AllocationCheck(aos.jack.jak.task.Task __t, berth.AllocationCheck __env)
    {
        __agent = __env.__agent;
        __ns = __env.__ns;
        __planTask = __t;
        __logic = __t.logic;
        bRqev = __env.bRqev;
        bRpev = __env.bRpev;
        aRqev = __env.aRqev;
        self = (berth.Berth) __ns.getIF(berth.Berth.class);
        SingleBerthLiftingArmBs = __env.SingleBerthLiftingArmBs;
        capacity = __logic.new_variable(java.lang.Integer.TYPE);
        liftingArmId = __logic.new_variable(java.lang.String.class);
    }
    
    public boolean init_sentinel(aos.jack.jak.agent.NameSpace __a)
    {
        bRqev = (jettyplanner.BerthRequest) __a.findEvent("jettyplanner.BerthRequest");
        if (bRqev == null) {
            warning("Failed to find BerthRequest bRqev");
            return false;
        }
        bRpev = (berth.BerthReply) __a.findEvent("berth.BerthReply");
        if (bRpev == null) {
            warning("Failed to find BerthReply bRpev");
            return false;
        }
        aRqev = (berth.AllocationRequest) __a.findEvent("berth.AllocationRequest");
        if (aRqev == null) {
            warning("Failed to find AllocationRequest aRqev");
            return false;
        }
        SingleBerthLiftingArmBs = (berth.MyLiftingArmBs) lookupNamedObject("SingleBerthLiftingArmBs","berth.MyLiftingArmBs",0);
        if (SingleBerthLiftingArmBs == null) {
            warning("Failed to find MyLiftingArmBs SingleBerthLiftingArmBs");
            return false;
        }
        return true;
    }
    
    public aos.jack.jak.plan.Plan freeze()
    {
        return this;
    }
    
    public aos.jack.jak.plan.Plan unfreeze()
    {
        return this;
    }
    
    public java.lang.Object genObject(int __index)
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Object Construction");
        return null;
    }
    
    public aos.jack.jak.cursor.Cursor genCursor(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Cursor Construction");
        return null;
    }
    
    public aos.jack.jak.fsm.FSM genFSM(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal FSM Construction");
        return null;
    }
    
    public boolean testCondition(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal test Construction");
        return false;
    }
    
    public aos.jack.jak.plan.PlanFSM body()
    {
        return new berth.AllocationCheck.__bodyFSM();
    }
    
    private AllocationCheck(jettyplanner.BerthRequest __ev, aos.jack.jak.task.Task __t, berth.AllocationCheck __env)
    {
        this(__t,__env);
        this.bRqev = __ev;
    }
    
    protected aos.jack.jak.logic.Signature eventSignature(int __log)
    {
        return bRqev.getSignature(__log);
    }
    
    public java.lang.String handledEvent()
    {
        return "jettyplanner.BerthRequest";
    }
    
    public boolean __relevant(aos.jack.jak.event.Event __e)
    {
        return __ns.isEnabled() && relevant(((jettyplanner.BerthRequest) __e));
    }
    
    public aos.jack.jak.plan.Plan createPlan(aos.jack.jak.event.Event __e, aos.jack.jak.task.Task __t)
    {
        if (!(__e instanceof jettyplanner.BerthRequest)) 
            return null;
        jettyplanner.BerthRequest __e1 = (jettyplanner.BerthRequest) __e;
        return new berth.AllocationCheck(__e1,__t,this);
    }
    
    protected aos.jack.jak.logic.Signature initSignature(int __log)
    {
        aos.jack.jak.logic.Signature __s = super.initSignature(__log + 2);
        __s.addLogical(capacity);
        __s.addLogical(liftingArmId);
        return __s;
    }
    
    public void setFromSignature(aos.jack.jak.logic.Signature __s)
    {
        super.setFromSignature(__s);
        capacity = __s.getLogical();
        liftingArmId = __s.getLogical();
    }
    
    public java.lang.String[] variableNames()
    {
        return __planVariableNames;
    }
    
    public java.lang.String[] variableTypes()
    {
        return __planVariableTypes;
    }
    
    public java.lang.Object getVariable(int n)
    {
        switch (n) {
            case 0: 
            {
                return aos.util.ToObject.box(capacity);
            }
            case 1: 
            {
                return aos.util.ToObject.box(liftingArmId);
            }
            case 2: 
            {
                return aos.util.ToObject.box(bRqev);
            }
            case 3: 
            {
                return aos.util.ToObject.box(bRpev);
            }
            case 4: 
            {
                return aos.util.ToObject.box(aRqev);
            }
            case 5: 
            {
                return aos.util.ToObject.box(self);
            }
            case 6: 
            {
                return aos.util.ToObject.box(SingleBerthLiftingArmBs);
            }
            default: 
            {
                throw new java.lang.IndexOutOfBoundsException("Plan " + this + " does not have variable number " + n);
            }
        }
    }
    
    public java.lang.String[] reasoningMethods()
    {
        return mergeReasoningMethods(__reasoningMethods,super.reasoningMethods());
    }
    
    public java.lang.String[] logSignatureVariableNames()
    {
        return __logSignatureVariableNames;
    }
    
    public java.lang.String[] logSignatureVariableTypes()
    {
        return __logSignatureVariableTypes;
    }
    
    public aos.jack.jak.cursor.Cursor context()
    {
        try {
            return (((true)?aos.jack.jak.cursor.Cursor.trueCursor:aos.jack.jak.cursor.Cursor.falseCursor));
        }
        catch (java.lang.Exception e) {
            e.printStackTrace();
            return aos.jack.jak.cursor.Cursor.falseCursor;
        }
    }
    
    class __bodyFSM extends aos.jack.jak.plan.PlanFSM implements aos.jack.jak.core.Generator {
        boolean __local__6_0;
        jettyplanner.BerthAlternative __local__6_1;
        aos.jack.jak.cursor.Cursor __local__6_2;
        java.lang.Exception __local__6_3;
        com.domainlanguage.time.TimePoint __local__6_4;
        com.domainlanguage.time.Duration __local__6_5;
        berth.AllocationRequest __local__6_6;
        berth.Bid __local__6_7;
        berth.Bid __local__6_8;
        private int __breakLevel = 0;
        public int run(int __status)
            throws java.lang.Throwable
        {
            do {
                try {
                    if (__tothrow != null) 
                        throw __tothrow;
                    if ((aos.jack.jak.core.Jak.debugging & aos.jack.jak.core.Jak.LOG_PLANS) != 0) 
                        aos.util.logging.LogMsg.log(this,aos.jack.jak.core.Jak.LOG_PLANS,__task + "-AllocationCheck.body:" + java.lang.Integer.toString(__state));
                    if (__task.nsteps > 0) {
                        __task.nsteps-- ;
                        if (__task.nsteps == 0) 
                            agent.changeFocus();
                    }
                    if (__state < 10) {
                        __status = super.stdrun(berth.AllocationCheck.this,__status);
                        if (__status != CONTINUE || agent.changing_focus) 
                            return __status;
                        continue;
                    }
                    __curstate = __state;
                    switch (__state) {
                        default: 
                        {
                            aos.jack.jak.core.Jak.error("AllocationCheck.body: Illegal state");
                            return FAILED_STATE;
                        }
                        //* (74)         boolean hasProduct = false;
                        case 10: 
                        {
                            __breakLevel = 0;
                            __local__6_0 = false;
                            __state = 11;
                            break;
                        }
                        //* (75)         BerthAlternative ba = null;
                        case 11: 
                        {
                            __local__6_1 = null;
                            __state = 12;
                            break;
                        }
                        //* (77)             for(Cursor c = SingleBerthLiftingArmBs.getProduct(liftingArmId, capacity, bRqev.product);c.next();){
                        case 12: 
                        {
                            __breakLevel = 2;
                            __local__6_2 = (aos.jack.jak.cursor.Cursor) genCursor(0);
                            __state = 13;
                            break;
                        }
                        //* (77)             for(Cursor c = SingleBerthLiftingArmBs.getProduct(liftingArmId, capacity, bRqev.product);c.next();){
                        case 13: 
                        {
                            if (__local__6_2.next()) 
                                __state = 14;
                             else 
                                __state = 17;
                            break;
                        }
                        //* (78)                 hasProduct = true;
                        case 14: 
                        {
                            __breakLevel = 6;
                            __state = 13;
                            __local__6_0 = true;
                            break;
                        }
                        //* (81)         catch(Exception e){
                        case 15: 
                        {
                            __breakLevel = 2;
                            __state = 16;
                            __local__6_3 = (java.lang.Exception) __current;
                            break;
                        }
                        //* (82)             System.out.println("Could not request for the right prodct");
                        case 16: 
                        {
                            __breakLevel = 4;
                            __state = 17;
                            java.lang.System.out.println("Could not request for the right prodct");
                            break;
                        }
                        //* (86)         if(!(hasProduct && (bRqev.length <= self.length) && (bRqev.width <= self.width) && (bRqev.draft <= self.draft)))
                        case 17: 
                        {
                            if (!(__local__6_0 && (bRqev.length <= self.length) && (bRqev.width <= self.width) && (bRqev.draft <= self.draft))) 
                                __state = 18;
                             else 
                                __state = 19;
                            break;
                        }
                        //* (71)     #reasoning method
                        case 18: 
                        {
                            __state = 31;
                            break;
                        }
                        //* (91)             TimePoint wantedArrivalTime = bRqev.arrivalTime;
                        case 19: 
                        {
                            __breakLevel = 2;
                            __local__6_4 = bRqev.arrivalTime;
                            __state = 20;
                            break;
                        }
                        //* (92)             Duration durationOfCharging = findDurationOfCharging(wantedArrivalTime);
                        case 20: 
                        {
                            __local__6_5 = findDurationOfCharging(__local__6_4);
                            __state = 21;
                            break;
                        }
                        //* (94)             AllocationRequest alreq = aRqev.findAllocation(bRqev.shipName, bRqev.arrivalTime, durationOfCharging);
                        case 21: 
                        {
                            __local__6_6 = aRqev.findAllocation(bRqev.shipName,bRqev.arrivalTime,__local__6_5);
                            __state = 22;
                            break;
                        }
                        //* (95)             @subtask(alreq);
                        case 22: 
                        {
                            __task.push(__local__6_6);
                            __state = -__state;
                            __subtask_pass = 23;
                            __subtask_fail = 4;
                            return SUBTASK;
                        }
                        //* (97)             if(!self.bidList.isEmpty()){
                        case 23: 
                        {
                            if (!self.bidList.isEmpty()) 
                                __state = 24;
                             else 
                                __state = 30;
                            break;
                        }
                        //* (98)                 Bid bestBid = (Bid)self.bidList.remove(0);
                        case 24: 
                        {
                            __breakLevel = 4;
                            __local__6_7 = (berth.Bid) self.bidList.remove(0);
                            __state = 25;
                            break;
                        }
                        //* (99)                 while(!self.bidList.isEmpty()){
                        case 25: 
                        {
                            if (!self.bidList.isEmpty()) 
                                __state = 26;
                             else 
                                __state = 29;
                            break;
                        }
                        //* (100)                     Bid bid = (Bid)self.bidList.remove(0);
                        case 26: 
                        {
                            __breakLevel = 8;
                            __local__6_8 = (berth.Bid) self.bidList.remove(0);
                            __state = 27;
                            break;
                        }
                        //* (101)                     if(bestBid.getCalculatedCost()>bid.getCalculatedCost()){
                        case 27: 
                        {
                            if (__local__6_7.getCalculatedCost() > __local__6_8.getCalculatedCost()) 
                                __state = 28;
                             else 
                                __state = 25;
                            break;
                        }
                        //* (102)                       bestBid =  bid;
                        case 28: 
                        {
                            __breakLevel = 10;
                            __state = 25;
                            __local__6_7 = __local__6_8;
                            break;
                        }
                        //* (105)                 ba = new BerthAlternative(self.getName(), self.getBerthId(), bestBid);
                        case 29: 
                        {
                            __state = 31;
                            __local__6_1 = new jettyplanner.BerthAlternative(self.getName(),self.getBerthId(),__local__6_7);
                            break;
                        }
                        //* (107)                 ba = null;
                        case 30: 
                        {
                            __breakLevel = 4;
                            __state = 31;
                            __local__6_1 = null;
                            break;
                        }
                        //* (111)          @reply(bRqev, bRpev.berthReply(ba));
                        case 31: 
                        {
                            __state = 32;
                            agent.reply(bRqev,bRpev.berthReply(__local__6_1));
                            break;
                        }
                        //* (71)     #reasoning method
                        case 32: 
                        {
                            if (__pending == null) 
                                __state = PASSED_STATE;
                            __tothrow = __pending;
                            break;
                        }
                    }
                }
                catch (java.lang.Throwable e) {
                    handleException(e,__exMap_body);
                }
            }
             while (!agent.changing_focus);
            return CONTINUE;
        }
        
        public java.lang.String methodName()
        {
            return "body";
        }
        
        __bodyFSM()
        {
        }
        
        public java.lang.String stateInfo()
        {
            int n = __curstate;
            java.lang.String file = __tt__body[0];
            java.lang.String method = __tt__body[1];
            if (n < 0) 
                n = -n;
            n -= (10 - 2);
            java.lang.String line = (n < 2)?"??":__tt__body[n];
            return file + ":" + line + " " + method + " [" + __curstate + "]";
        }
        
        public java.lang.Object genObject(int __index)
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Object Construction");
            return null;
        }
        
        public aos.jack.jak.cursor.Cursor genCursor(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
                case 0: 
                {
                    return (SingleBerthLiftingArmBs.getProduct(liftingArmId,capacity,bRqev.product));
                }
            }
            aos.jack.jak.core.Jak.error("illegal Cursor Construction");
            return null;
        }
        
        public aos.jack.jak.fsm.FSM genFSM(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal FSM Construction");
            return null;
        }
        
        public boolean testCondition(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal test Construction");
            return false;
        }
        
        public aos.jack.jak.plan.Plan getPlan()
        {
            return berth.AllocationCheck.this;
        }
        
        protected aos.jack.jak.fsm.FSM fail()
        {
            return getPlan().fail();
        }
        
        protected aos.jack.jak.fsm.FSM pass()
        {
            return getPlan().pass();
        }
        
        public void enter()
        {
            __trace = agent.trace("berth.AllocationCheck.body");
        }
        
        public java.lang.Object getVariable(int n)
        {
            switch (n) {
                case 0: 
                {
                    return aos.util.ToObject.box(__local__6_0);
                }
                case 1: 
                {
                    return aos.util.ToObject.box(__local__6_1);
                }
                case 2: 
                {
                    return aos.util.ToObject.box(__local__6_2);
                }
                case 3: 
                {
                    return aos.util.ToObject.box(__local__6_3);
                }
                case 4: 
                {
                    return aos.util.ToObject.box(__local__6_4);
                }
                case 5: 
                {
                    return aos.util.ToObject.box(__local__6_5);
                }
                case 6: 
                {
                    return aos.util.ToObject.box(__local__6_6);
                }
                case 7: 
                {
                    return aos.util.ToObject.box(__local__6_7);
                }
                case 8: 
                {
                    return aos.util.ToObject.box(__local__6_8);
                }
                default: 
                {
                    throw new java.lang.IndexOutOfBoundsException("Reasoning Method " + methodName() + " does not have variable number " + n);
                }
            }
        }
        
        public java.lang.String[] variableNames()
        {
            return __fsmVariableNames_body;
        }
        
        public java.lang.String[] variableTypes()
        {
            return __fsmTypes_body;
        }
        
        public java.lang.String[] variableLocalNames()
        {
            return __fsmLocalNames_body;
        }
        
    }
}
