/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  This code is generated by JAC version 5.0 by
  Agent Oriented Software. http://www.agent-software.com.au

    DO NOT ALTER THIS CODE AND DO NOT REMOVE THIS COMMENT
 *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
package berth;
import aos.jack.jak.agent.Agent;
import java.util.ArrayList;

/** Berth-agent entity 
 * 
 *A Berth-agent is instanciated with static variables for capacity and size.
 *A berht-agent has several get- and set methods to take care of the variables
 *
 *@author Mari Torgersrud Haug
 *@author Elin M Kristensen
 *@version 29.05.06 
 *
 *@see RequestHandling
 *@see ReceiveShipResponsibility
 *@see ShipRemover
 *@see InitiationOfLiftingArm
 *@see LiftingArmInitiation
*/

public class Berth extends aos.jack.jak.agent.Agent {
    public java.util.ArrayList shipList;
    public java.util.ArrayList bidList;
    public java.util.ArrayList liftingArmList;
    public java.lang.String agentName;
    public int id;
    public int length;
    public int width;
    public double draft;
    public berth.CostCalculator myCostCalculator;
    public berth.RequestHandling cap;
    public berth.ReceiveShipResponsibility cap1;
    public berth.ShipRemover cap3;
    public berth.InitiationOfLiftingArm cap4;
    private berth.LiftingArmInitiation ev1;
    /**
     * The constructor instanciate a Berth-agent.
     * @param int id
     * @param String name
     * @param ArrayList liftingArmList
     * @param int length
     * @param int width
     * @param double draft
     */

    public Berth(int id, java.lang.String name, java.util.ArrayList liftingArmList, int length, int width, double draft)
    {
        super(name);
        boolean __b = getAgentType() == berth.Berth.class;
        if (__b) {
            __init1();
            __init2();
        }
        this.agentName = name;
        this.id = id;
        this.liftingArmList = liftingArmList;
        this.length = length;
        this.width = width;
        this.draft = draft;
        shipList = new java.util.ArrayList();
        myCostCalculator = new berth.CostCalculator();
        if (liftingArmList != null) 
            postEvent(ev1.initiateLiftingArms(liftingArmList));
        bidList = new java.util.ArrayList();
        if (__b) 
            startAgent();
    }
    
    /**
     * This method returns the berth's liftingarm list
     * @return ArrayList liftingArmList
     */

    public java.util.ArrayList getLiftingArmList()
    {
        return liftingArmList;
    }
    
    /**
     * This method returns the name of the berth
     * @return String agentName
     */

    public java.lang.String getAgentName()
    {
        return agentName;
    }
    
    /**
     * This method returns the berth ID
     * @return int id
     */

    public int getBerthId()
    {
        return id;
    }
    
    /**
     * A ship is added to the berth's shiplist.
     * The list contains String-objects
     * @param int index
     * @param String ship
     */

    public void addShip(int index, java.lang.String ship)
    {
        shipList.add(index,ship);
    }
    
    /**
     * This method returns the berth's length
     * @return int length
     */

    public int getBerthLength()
    {
        return length;
    }
    
    /**
     * A bid is added to the berth's bidList
     * @param Bid bid
     */

    public void addBid(berth.Bid bid)
    {
        bidList.add(bid);
    }
    
    /**
     * This method returns the Berth's bidList
     * @return bidList
     */

    public java.util.ArrayList getBid()
    {
        return bidList;
    }
    
    /**
     * This method checks if wether the bidlist is empty
     * @return boolean true or false
     */

    public boolean bidIsSet()
    {
        return !bidList.isEmpty();
    }
    
    /**
     * This method checks if the Berth has a product
     * @param String product
     * @return boolean true or false
     */

    public boolean hasProduct(java.lang.String product)
    {
        boolean hasProduct = false;
        for (int i = 0; i < liftingArmList.size(); i++ ) {
            berth.LiftingArm liftingArm = (berth.LiftingArm) liftingArmList.get(i);
            boolean tempHasProduct = liftingArm.hasProduct(product);
            if (tempHasProduct) 
                hasProduct = tempHasProduct;
        }
        return hasProduct;
    }
    
    /**
     * This method delete ships from the Berth's shipList
     * @param ArrayList shipToMove
     */

    public void deleteShips(java.util.ArrayList shipToMoove)
    {
        for (int i = 0; i < shipToMoove.size(); i++ ) {
            java.lang.String ship = (java.lang.String) shipToMoove.get(i);
            remove(ship);
        }
    }
    
    /**
     * Only one ship is removed from the shipList
     * @param String ship
     * @return boolean true or false
     */

    public boolean remove(java.lang.String ship)
    {
        for (int i = 0; i < shipList.size(); i++ ) {
            java.lang.String tempShip = (java.lang.String) shipList.get(i);
            if (ship.equals(tempShip)) {
                shipList.remove(i);
                return true;
            }
        }
        return false;
    }
    
    /**
     * Each liftingarm has it's own capacity. This method finds the total capacity
     * a berth can offer for a special kind of product.
     * @param String product
     * @return int totalCapacity
     */

    public int findTotLACapacity(java.lang.String product)
    {
        int totalCapacity = 0;
        for (int i = 0; i < liftingArmList.size(); i++ ) {
            berth.LiftingArm liftingArm = (berth.LiftingArm) liftingArmList.get(i);
            boolean tempHasProduct = liftingArm.hasProduct(product);
            if (tempHasProduct) 
                totalCapacity = totalCapacity + liftingArm.getCapacity();
        }
        return totalCapacity;
    }
    
    public java.lang.String getDocumentation()
    {
        return "/** Berth-agent entity \n * \n *A Berth-agent is instanciated with static variables for capacity and size.\n *A berht-agent has several get- and set methods to take care of the variables\n *\n *@author Mari Torgersrud Haug\n *@author Elin M Kristensen\n *@version 29.05.06 \n *\n *@see RequestHandling\n *@see ReceiveShipResponsibility\n *@see ShipRemover\n *@see InitiationOfLiftingArm\n *@see LiftingArmInitiation\n*/\n";
    }
    
    public java.lang.Class getAgentType()
    {
        return berth.Berth.class;
    }
    
    public void __init1()
    {
        super.__init1();
        if (cap == null) {
            cap = new berth.RequestHandling(this);
            cap.__initCapability(this,"cap");
        }
        cap.__init1();
        if (cap1 == null) {
            cap1 = new berth.ReceiveShipResponsibility(this);
            cap1.__initCapability(this,"cap1");
        }
        cap1.__init1();
        if (cap3 == null) {
            cap3 = new berth.ShipRemover(this);
            cap3.__initCapability(this,"cap3");
        }
        cap3.__init1();
        if (cap4 == null) {
            cap4 = new berth.InitiationOfLiftingArm(this);
            cap4.__initCapability(this,"cap4");
        }
        cap4.__init1();
    }
    
    public void __init2()
    {
        super.__init2();
        cap.__init2();
        cap1.__init2();
        cap3.__init2();
        cap4.__init2();
        ev1 = (berth.LiftingArmInitiation) findEvent("berth.LiftingArmInitiation");
    }
    
    synchronized private void __init_desc()
    {
        cap = new berth.RequestHandling(this);
        cap.__initCapability(this,"cap");
        cap.init_desc();
        cap1 = new berth.ReceiveShipResponsibility(this);
        cap1.__initCapability(this,"cap1");
        cap1.init_desc();
        cap3 = new berth.ShipRemover(this);
        cap3.__initCapability(this,"cap3");
        cap3.init_desc();
        cap4 = new berth.InitiationOfLiftingArm(this);
        cap4.__initCapability(this,"cap4");
        cap4.init_desc();
        addEvent("berth.LiftingArmInitiation",aos.jack.jak.agent.Agent.POSTED_EVENT);
    }
    
    public void init_desc()
    {
        newAgentDesc("Berth");
        super.init_desc();
        __init_desc();
    }
    
    synchronized public void __bindNames()
    {
        super.__bindNames();
        cap.__bindNames();
        cap1.__bindNames();
        cap3.__bindNames();
        cap4.__bindNames();
    }
    
    public void setEnabled(boolean t)
    {
        super.setEnabled(t);
        cap.setEnabled(t);
        cap1.setEnabled(t);
        cap3.setEnabled(t);
        cap4.setEnabled(t);
    }
    
}
