package berth;



























import com.domainlanguage.time.*;















import com.domainlanguage.timeutil.*;














import ship.Ship;













import java.io.Serializable;












import java.util.ArrayList;










/** Class for incapsulate the attributes related to a Bid
 * 
 * Creates a Bid with related attributes
 * The Bid is made when a Berth agent check its allocation
 * possibilities for a given Ship
 *
 * @author      Elin Marie Kristensen
 * @author      Mari Torgersrud Haug
 * @version     18.05.2006
 * @see         Berth, Ship
 */















public class Bid implements Serializable{




























    private String shipName;













    private int calculatedCost;













    private TimePoint suggestedArrivalTime;













    private TimePoint suggestedDepartureTime;













    public ArrayList shipToBeMoved;










    public int index;







    
/** Constructor for Bid
  *
  * Set the attributes from the parameters that are input to the constructor
  * 
  * @param String shipName of the ship that is made a Bid on
  * @param int calculatedCost for allocating the ship
  * @param TimePoint suggestedArrivalTime
  * @param TimePoint suggestedDepartureTime
  * @param int the index in the list where the Berth keep its Ships 
  * @param ArrayList a list keeping the name of ships that must be removed after allocation of the ship
  */
   public Bid(String shipName, int calculatedCost, TimePoint suggestedArrivalTime, TimePoint suggestedDeparture, int index, ArrayList shipToBeMoved){













        this.shipName = shipName;













        this.calculatedCost = calculatedCost;













        this.suggestedArrivalTime = suggestedArrivalTime;













        this.suggestedDepartureTime = suggestedDeparture;













        this.shipToBeMoved = shipToBeMoved;













        this.index = index;










    }













    
/** Get-method for the shipName attribute
  *
  * @return String 
  */













    public String getShip(){













        return shipName;













    }













/** Get-method for the calculatedCost attribute
  *
  * @return int
  */
 














    public int getCalculatedCost(){















        return calculatedCost;













    }













/** Get-method for the suggestedArrivalTime attribute
  *
  * @return TimePoint
  */
    public TimePoint getSuggestedArrivalTime(){













        return suggestedArrivalTime;













    }


























/** Get-method for the suggestedDepartureTime attribute
  *
  * @return TimePoint
  */
    

public TimePoint getSuggestedDepartureTime(){















      return suggestedDepartureTime;













    }













    
/** Get-method for the index attribute
  *
  * @return int
  */    
   public int getIndex(){







        return index;







    }







/** Get-method for the shipToBeMoved list
  *
  * @return ArrayList
  */        






    public ArrayList getShipToMove(){






        return shipToBeMoved;






    }





















}