package berth;



import java.util.*;


/** Class for incapsulate the attributes related to a LiftingArm
 * 
 * Creates a LiftingArm with related attributes
 * The Bid is made when a Berth agent reads data from its beliefset
 *
 * @author      Elin Marie Kristensen
 * @author      Mari Torgersrud Haug
 * @version     18.05.2006
 * @see         Berth
 */
public class LiftingArm{

    private String liftingArmId;

    private int capacity;

    private ArrayList productList;



/** Constructor for LiftingArm
  *
  * Set the liftingArmId and make a new productList
  *
  * @param String liftingArmId
  */
    public LiftingArm(String liftingArmId){

        this.liftingArmId = liftingArmId;

        productList = new ArrayList();

    }

/** Get-method for the liftingArmId
  *
  * @return String
  */

    public String getLiftingArmId(){

        return liftingArmId;

    }

/** Method that add a new product to this LiftingArms productList
  *
  * @param String product name of product
  */         

    public void addProduct(String product){

        productList.add(product);

    }


/** Get-method for the productList
  *
  * @return ArrayList
  */  
    public ArrayList getProductList(){

        return productList;

    }

/** Set-method for the capacity
  *
  * @param int capacity
  */       

    public void setCapacity(int capacity){

        this.capacity = capacity;        

    }

/** Get-method for the capacity
  *
  * @return int
  */      

    public int getCapacity(){

        return capacity;

    }



/** Method to check wether this LiftingArm has a specific product
  *
  * @param String product name of product
  * @return boolean
  */ 
    public boolean hasProduct(String product){

        boolean hasProduct = false;

        for(int i = 0; i < productList.size(); i++){

            String liftingArmProduct = (String)productList.get(i);

            if(liftingArmProduct.equals(product))

                hasProduct = true;

        }

        return hasProduct;

    }

}  

  

