/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  This code is generated by JAC version 5.0 by
  Agent Oriented Software. http://www.agent-software.com.au

    DO NOT ALTER THIS CODE AND DO NOT REMOVE THIS COMMENT
 *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
package gui;
import aos.jack.jak.event.Event;
import java.util.ArrayList;
import com.domainlanguage.time.TimePoint;

/** View to connect a customized JettyWindow to the rest of the agent system.
  *
  * The view contain methods that post event to the agent system, and
  * that invoke methods in the JettyWindow
  * 
  * @author      Elin Marie Kristensen
  * @author      Mari Torgersrud Haug
  * @version     29.05.2006
  * @see         JettyWindow
  */

public class Screen implements aos.jack.plugin.view.rt.ViewMarker, aos.jack.jak.event.EventSource {
    private gui.JettyWindow window;
    public aos.jack.jak.event.EventRecipient _event_recipient;
    public gui.submitShip sAev;
    /** Constructor for Screen
     * 
     * This constructor instaciate this applications window.
     */

    public Screen()
    {
        window = new gui.JettyWindow("JettyPlanner",this);
    }
    
    /** Method for initializing the JettyWindow
     * 
     * This method call methods in the JettyWindow, with lists
     * containing Ships and Berths
     * 
     * @param ArrayList berthList
     * @param ArrayList shipList
     */

    public void initWindow(java.util.ArrayList berthList, java.util.ArrayList shipList)
    {
        window.initShipPanel(shipList);
        window.initBerthPanel(berthList);
    }
    
    /** Method when a ship is submitted
     * 
     * This method post an event to a plan for the GUI agent,
     * to inform that ship information is submitted
     * 
     * @param String shipName
     * @param String product
     * @param TimePoint arrivalTime
     */

    public void submitShip(java.lang.String shipName, java.lang.String product, com.domainlanguage.time.TimePoint arrivalTime)
    {
        postEvent(sAev.addSubmittedShip(shipName,product,arrivalTime));
    }
    
    /** Method for displaying a ship
     * 
     * This method call an insert method in the JettyWindow, 
     * with the ship that should be displayed and id for the Berth it should be allocated to.
     * 
     * @param int berthId
     * @param String shipName
     * @param TimePoint delegatedArrivalTime
     * @param TimePoint departureTime
     */

    public void displayShip(int berthId, java.lang.String shipName, com.domainlanguage.time.TimePoint delegatedArrivalTime, com.domainlanguage.time.TimePoint departureTime)
    {
        window.insertShip(berthId,shipName,delegatedArrivalTime,departureTime);
    }
    
    public java.lang.String getDocumentation()
    {
        return "/** View to connect a customized JettyWindow to the rest of the agent system.\n  *\n  * The view contain methods that post event to the agent system, and\n  * that invoke methods in the JettyWindow\n  * \n  * @author      Elin Marie Kristensen\n  * @author      Mari Torgersrud Haug\n  * @version     29.05.2006\n  * @see         JettyWindow\n  */\n";
    }
    
    public void postEvent(aos.jack.jak.event.Event e)
    {
        _event_recipient.postEvent(e);
    }
    
    public boolean attach(aos.jack.jak.event.EventRecipient er)
    {
        if ((sAev = (gui.submitShip) _findEvent(er,gui.submitShip.class.getName())) == null) 
            return false;
        _event_recipient = er;
        return true;
    }
    
    public aos.jack.jak.event.Event _findEvent(aos.jack.jak.event.EventRecipient er, java.lang.String en)
    {
        aos.jack.jak.event.Event ev = er.findEvent(en);
        if (ev != null) 
            return ev;
        ((aos.jack.jak.agent.NameSpace) er).getAgent().warning("View type Screen failed attaching event type " + en);
        return null;
    }
    
}
