package gui;












import javax.swing.*;












import java.awt.Component;












import javax.swing.table.*;

























/** Class for making a customized Button renderer
  *
  * This class is used by the submitButtons in the table in ShipPanel
  * It implements the TableCellRenderer interface.
  * 
  * @author      Elin Marie Kristensen
  * @author      Mari Torgersrud Haug
  * @version     18.05.2006
  * @see         ShipPanel
  */

public class SubmitRenderer extends JButton implements TableCellRenderer{












  public SubmitRenderer() {












    setOpaque(true);












  }

























 /** Method that make this renderers component and returns a reference
  * 
  * @param JTable table that is asking the reenderer to reender
  * @param value the value of the cell to be reendered
  * @param boolean isSelected is true if the cell is to be rendered with highlighting
  * @param boolean hasFocus true if cell has focus
  * @param row of the cell being reendered
  * @param column of the cell being reendered
  * 
  * @return Component
  */  

  public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {












    if (isSelected) {












      setForeground(table.getSelectionForeground());












      setBackground(table.getSelectionBackground());












      setEnabled(false);



    } 












    else {












      setForeground(table.getForeground());












      setBackground(UIManager.getColor("Button.background"));












    }












      setText("Submit");












      return this;












  }












  








}












