package jettyplanner;





























import berth.Bid;

















import java.io.Serializable;





































/** Class that represent an alternative allocation of a Ship to a Berth 


  *


  * This class contains get methods for the variables


  *


  * @author      Elin Marie Kristensen


  * @author      Mari Torgersrud Haug


  * @version     18.05.2006


  */

















public class BerthAlternative implements Serializable{




























    String berthName;














    int berthId;











    String ship;





















    int cost;














    Bid bid;














  /** Constructor that set the name of the Berth and Bid from the Berth


    *


    * @param   berthName name of the berth contained in this alternative


    * @param   bid the bid for the berth on a ship


    * @see     Bid


    */  





























    public BerthAlternative(String berthName, int berthId, Bid bid){














        this.berthName = berthName;














        this.berthId = berthId;











        this.bid = bid;










    }














    


  /** Get method for the Berths name


    *


    * @return  berth name


    * @see     String


    */











    public String getBerthName(){



















        return berthName;














    }














  /** Get method for the Berths identification number


    *


    * @return  id number for the berth


    */


    public int getBerthId(){




        return berthId;




   }




   


  /** Get method for the ship


    *


    * @return  a ahip object


    * @see     Ship


    */
















    public String getShip(){





















        return bid.getShip();





















    }






























  /** Get method for the calculatedCost


   * 


   * The cost is calculated when a berth checks for allucation on a ship, and come up with a bid.


   *


   * @return  calculated cost value


   */


    public int getCost(){




















        return bid.getCalculatedCost();














    }










    


   /** Get method for the Bid in this alternative


   * 


   * The cost is calculated when a berth checks for allucation on a ship, and come up with a bid.


   *


   * @return this class bid object


   * @see Bid


   */    










    public Bid getBid(){










        return bid;










    }

























   /** Method that makes a string representation of this object


   * 


   * @return a String representation for this object


   * @see String


   */      













    public String toString(){













        return "BerthAlternative: "+"ship: "+getShip()+" berth: "+getBerthName()+" cost: "+getCost();













    }













    



























}